﻿var dialogProductFieldSettings, dialogProductFieldDelete, deleteId, $elementForDelete;
$(document).ready(function () {
    initBsTooltip();

    dialogProductFieldSettings = $("#DialogProductFieldSettings").dialog({
        autoOpen: false,
        resizable: false,
        width: "600",
        height: "auto",
        modal: true,
        buttons:
            [{
                text: Localization_Save,
                click: function () {
                    $("#ItemsError").hide();
                    if ($("#ProductFieldSettingsCustomFieldType").val() == "DropDown" && $(".product-field-items .product-field-item").length <= 0) {
                        $("#ItemsError").show();
                    }
                    else {
                        SaveSettings();
                    }
                }
            }, {
                text: Localization_Cancel,
                click: function () {
                    dialogProductFieldSettings.dialog("close");
                }
            }]
    });

    dialogProductFieldDelete = $("#DialogProductFieldDelete").dialog({
        autoOpen: false,
        resizable: false,
        width: "600",
        height: "auto",
        modal: true,
        buttons:
        [{
            text: Localization_Yes,
            click: function () {
                $.ajax({
                    url: RQ_URL + "/Admin/ProductFields/Delete",
                    type: "POST",
                    data: JSON.stringify({
                        id: deleteId,
                    }),
                    dataType: "html",
                    contentType: "application/json; charset=utf-8",
                    success: function (g) {
                    },
                    error: function (error) { alert(error.responseText); },
                    complete: function () {
                        $elementForDelete.closest(".product-field").detach();
                        dialogProductFieldDelete.dialog("close");
                    }
                });
            }
        }, {
            text: Localization_No,
            click: function () {
                dialogProductFieldDelete.dialog("close");
            }
        }]
    });

    $(".draggable").draggable({
        connectToSortable: '#sortable',
        helper: "clone",
        stop: function (event, ui) {
            if ($("#sortable").find(".draggable").length > 0) {
                var position = $("#sortable").find(".draggable").index();
                var type = $("#sortable").find(".draggable").data("type");
                $("#sortable").find(".draggable").html("<div class='loading-32'></div>");
                $.ajax({
                    url: RQ_URL + "/Admin/ProductFields/AddType",
                    type: "POST",
                    data: JSON.stringify({
                        productId: productId,
                        type: type,
                        index: position,
                    }),
                    dataType: "html",
                    contentType: "application/json; charset=utf-8",
                    success: function (g) {
                        if (position == 0) {
                            $("#sortable").prepend(g);
                        } else {
                            $("#sortable > div.product-field:nth-child(" + (position) + ")").after(g);
                        }
                        $("#sortable").find(".draggable").detach();
                        initBsTooltip();
                    },
                    error: function (error) { alert(error.responseText); },
                    complete: function () {
                    }
                });
            }
            initBsTooltip();
        },
    });

    $("#sortable, div.product-field").disableSelection();
    $("#sortable").droppable({
        accept: "div.draggable",
        drop: function (event, ui) {
        },
    }).sortable({
        items: ".product-field",
        handle: ".handle",
        placeholder: "ui-state-highlight-product-field",
        stop: function (event, ui) {
            var position = $("#sortable").find(".draggable").index();
            var ids = $(".product-fields-left-box .content .product-field").map(function () {
                return $(this).data("id");
            }).get();
            $.ajax({
                url: RQ_URL + "/Admin/ProductFields/ChangePositions",
                type: "POST",
                data: JSON.stringify({
                    ids: ids
                }),
                dataType: "html",
                contentType: "application/json; charset=utf-8",
                success: function (g) {
                    $("#sortable").find(".draggable").detach();
                },
                error: function (error) { alert(error.responseText); },
                complete: function () {
                }
            });
        }
    });

    $(".product-fields-left-box").on("click", ".product-field .fa-cog", function () {
        var id = $(this).closest(".product-field").data("id");
        dialogProductFieldSettings.html("<div class='loading-32'></div>");
        dialogProductFieldSettings.dialog("open");
        $.ajax({
            url: RQ_URL + "/Admin/ProductFields/GetSettings",
            type: "POST",
            data: JSON.stringify({
                id: id,
            }),
            dataType: "html",
            contentType: "application/json; charset=utf-8",
            success: function (g) {
                dialogProductFieldSettings.html(g);
                initSortableDropDownItems();
                if ($("#ProductFieldSettingsCustomFieldType").val() == "DropDown") {
                    if ($("#ProductFieldSettingsPleaseSelect").is(":checked")) {
                        $("#ProductFieldSettingsRequired").prop("disabled", false);
                    }
                    else {
                        $("#ProductFieldSettingsRequired").prop("disabled", true);
                        $("#ProductFieldSettingsRequired").prop("checked", false);
                    }
                }
                dialogProductFieldSettings.dialog("close");
                dialogProductFieldSettings.dialog("open");
                initBsTooltip();
            },
            error: function (error) { alert(error.responseText); },
            complete: function () {
            }
        });
    });

    $(".product-fields-left-box").on("click", ".product-field .fa-trash", function () {
        dialogProductFieldDelete.dialog("open");
        deleteId = $(this).closest(".product-field").data("id");
        $elementForDelete = $(this);
       
    });

    $("#DialogProductFieldSettings").on("click", "#ProductFieldSettingsPleaseSelect", function () {
        if ($("#ProductFieldSettingsCustomFieldType").val() == "DropDown") {
            if ($(this).is(":checked")) {
                $("#ProductFieldSettingsRequired").prop("disabled", false);
            }
            else {
                $("#ProductFieldSettingsRequired").prop("disabled", true);
                $("#ProductFieldSettingsRequired").prop("checked", false);
            }
        }
    });

    $("#DialogProductFieldSettings").on("click", ".product-field-item .fa-trash-o", function () {
        $(this).closest(".product-field-item").remove();
    });
});

function SaveSettings() {
    OnAjaxBegin(Localization_Saving);
    if ($("#ProductFieldSettingsCustomFieldType").val() == "ID" && $("#ProductFieldSettingsUnique").is(":checked")) {
        $.ajax({
            url: RQ_URL + "/Admin/ProductFields/CheckIsUnique",
            type: "POST",
            data: JSON.stringify({
                Id: $("#ProductFieldSettingsId").val(),
            }),
            dataType: "json",
            contentType: "application/json; charset=utf-8",
            success: function (g) {
                if (g == true) {
                    CallSaveSettings();
                }
                else {
                    OnAjaxComplete();
                    $("#ProductFieldSettingsUnique").closest(".form-group").find(".valid-error").show();
                }
            },
            error: function (error) { alert(error.responseText); },
            complete: function () {
            }
        });
    }
    else {
        CallSaveSettings();
    }
}

function CallSaveSettings() {
    var items = Array();
    $(".product-field-items .product-field-item").each(function (index, value) {
        items.push({
            IsNew: $(value).data("isnew"),
            Id: $(value).data("id"),
            Index: index,
            Title: $(value).find("input[type='text']").val(),
        });
    });

    $.ajax({
        url: RQ_URL + "/Admin/ProductFields/SaveSettings",
        type: "POST",
        data: JSON.stringify({
            Id: $("#ProductFieldSettingsId").val(),
            CustomFieldTitle: $("#ProductFieldSettingsCustomFieldTitle").val(),
            ShowInSelect: $("#ProductFieldSettingsShowInSelect").is(":checked"),
            DoNotShowInTicket: $("#ProductFieldSettingsDoNotShowInTicket").is(":checked"),
            Required: $("#ProductFieldSettingsRequired").is(":checked"),
            HintText: $("#ProductFieldSettingsHintText").val(),
            PleaseSelect: $("#ProductFieldSettingsPleaseSelect").is(":checked"),
            MinLength: $("#ProductFieldSettingsMinLength").val(),
            MaxLength: $("#ProductFieldSettingsMaxLength").val(),
            Description: $("#ProductFieldSettingsDescription").val(),
            Items: items
        }),
        dataType: "html",
        contentType: "application/json; charset=utf-8",
        success: function (g) {
            var id = $("#ProductFieldSettingsId").val();
            $(".product-field[data-id='" + id + "']").after(g);
            $(".product-field[data-id='" + id + "']").first().detach();
            dialogProductFieldSettings.dialog("close");
            initBsTooltip();
        },
        error: function (error) { alert(error.responseText); },
        complete: function () {
            OnAjaxComplete();
        }
    });
}

function addNewRow() {
    $(".product-field-items").append("<div class='product-field-item' data-isnew='true'> <i class='fa fa-fw fa-arrows handle'></i><input type='text' /><i class='fa fa-fw fa-trash-o cursor_pointer'></i></div>");
    initSortableDropDownItems();
}

function initSortableDropDownItems() {
    $(".product-field-items").sortable({
        items: ".product-field-item",
        handle: ".handle"
    });
}