﻿//JQUERY READY FUNCTION CANNOT BE HERE FOR AJAX CONTROLS (CONSTANTLY REALOADED)


// ---- SignalR --------
$(document).ready(function () {
    //// Create a function that the hub can call back to display messages.
    $.connection.ticketViewHub.client.addNewMessageToPage = function (ticketMessageId, userProviderKey, notificationText) {
        $.playSound(RQ_URL + '/Sounds/ticket-user-message.mp3');

        // Add the message to the page. 
        if (userProviderKey != LoggedUserProviderKey) {
            $.notify(notificationText, {
                animate: {
                    enter: 'animated zoomInDown',
                    exit: 'animated zoomOutUp',
                },
                delay: 5000,
                allow_dismiss: false,
            });
        }

        $.ajax({
            url: RQ_URL + '/Tickets/PartialTicketUserMessage?ticketId=' + ticketId + '&ticketMessageId=' + ticketMessageId,
            type: "GET",
            dataType: "html",
            contentType: "application/json; charset=utf-8",
            cache: false,
        }).done(function (data) {

            if ($('div.timeline div.comment[data-id=' + ticketMessageId + ']').length == 0) { //it can be posted a new message just right when signalR adds new message too (and the message could be loaded on the page already)
                $("div#async-message-insert-here").after(data);
                InitShowEmailQuoteButtons('div.timeline div.comment[data-id=' + ticketMessageId + '] .communication-comment');
            }

            var $li = $('div.timeline div.comment[data-id=' + ticketMessageId + ']');

            var cookie = $.cookie("TicketViewShowMessagesType-" + LoggedUserProviderKey);
            var show = cookie == undefined || cookie == "COMMENTS_ONLY" || cookie == "ALL" || cookie == "PUBLIC_COMMENTS_ONLY" && !$li.hasClass('private');

            if (show) {
                $li.show('medium');
                $li.addClass('animated pulse');
                $li.find('.timeline-panel').addClass('async');
            }

        }).fail(function (error) {
            alert(error.responseText);
        });
    };

    $.connection.ticketViewHub.client.editMessageOnPage = function (ticketMessageId, userProviderKey, notificationText) {
        $.playSound(RQ_URL + '/Sounds/ticket-user-message.mp3');

        // Edit the message on the page. 
        if (userProviderKey != LoggedUserProviderKey) {
            $.notify(notificationText, {
                animate: {
                    enter: 'animated zoomInDown',
                    exit: 'animated zoomOutUp',
                },
                delay: 5000,
                allow_dismiss: false,
            });
        }

        RefreshTicketUserMessageAjax(ticketMessageId, true);
    };

    $.connection.ticketViewHub.client.deleteMessageFromPage = function (ticketMessageId) {
        // Delete the message from the page. 
        RefreshTicketUserMessageAjax(ticketMessageId, false);
    };

    $.connection.ticketViewHub.client.addNewStickyNoteToPage = function (ticketStickyNoteId) {
        // Add the message to the page. 
        $.ajax({
            url: RQ_URL + '/Tickets/PartialTicketStickedNote?ticketId=' + ticketId + '&ticketStickyNoteId=' + ticketStickyNoteId,
            type: "GET",
            dataType: "html",
            contentType: "application/json; charset=utf-8",
            cache: false,
        }).done(function (data) {

            if ($('.ticket-sticky-notes .ticket-sticky-note[data-id=' + ticketStickyNoteId + ']').length == 0) {
                $(".ticket-sticky-notes").prepend(data);
            }

            var $div = $('.ticket-sticky-notes .ticket-sticky-note[data-id=' + ticketStickyNoteId + ']');
            $div.show('medium');
            $div.addClass('animated pulse');
            $div.find('.timeline-panel').addClass('async');
        }).fail(function (error) {
            alert(error.responseText);
        });
    };

    $.connection.ticketViewHub.client.editStickyNoteOnPage = function (ticketStickyNoteId) {
        RefreshTicketStickyNoteAjax(ticketStickyNoteId, true);
    };

    $.connection.ticketViewHub.client.deleteStickyNoteFromPage = function (ticketStickyNoteId) {
        var $div = $('.ticket-sticky-notes .ticket-sticky-note[data-id=' + ticketStickyNoteId + ']');

        $div.hide('medium', function () {
            $(this).remove();
        });
    };


    // ------------ hiding right boxes
    $("#ticketViewDiv").on("click", "#ticket-right .block.rolled-up .block-header", function () { //#ticketViewDiv se nepřepisuje ajaxem
        var blockbody = $(this).next($(".block-body"));
        var opener = $(this).find($(".opener"));
        opener.text(opener.text() == "▼" ? "►" : "▼");
        blockbody.slideToggle();
    });

    $("#ticketViewDiv").on("click", "#ticket-right .iframe-widget-title", function () { //#ticketViewDiv se nepřepisuje ajaxem
        var iframe = $(this).next($("iframe"));
        var opener = $(this).find($(".opener"));
        opener.text(opener.text() == "▼" ? "►" : "▼");
        iframe.slideToggle();
    });

    $("#ticketViewDiv").on("click", ".comment-message img", function () { //#ticketViewDiv se nepřepisuje ajaxem
        if ($(this).hasClass('full-size')) {
            $(this).removeClass('full-size');
        }
        else if ($(this).width() == $(this).parent().width()) { //zvetsovat pujdou jen obrazky, ktere jsou na maximu sirky kontejneru
            $(this).addClass('full-size');
        }
    });


    // ------------ messages type
    $("#ticketViewDiv").on("click", "#divMessagesType > button", function () { //#ticketViewDiv se nepřepisuje ajaxem
        messagesType = $(this).data("message-type");
        ShowMessagesType(messagesType, 'medium');
    });
});


// ------------------- AJAX FORM ----------------------------------

function OnBegin() {
    var action = $('#hiddenActionTicketView').val();
    OnAjaxBegin();
}

function OnSuccess() {
    //reinit tooltips
    $('#ticketViewDiv [data-toggle="tooltip"][title]').tooltipBS({ container: 'body' });

    OnAjaxSuccess();
}


// ------------------- ANIMATE DEADLINE PROGRESS ------------------

function AnimateDeadline(perc) {
    if (deadlineAnimation) {
        var tic__meterrunning = false;

        if (!tic__meterrunning) {
            tic__meterrunning = true;
            var tic__count = 0;
            var tic__inter = null;
            function tic__run() {
                tic__count++;
                $("#tic__meter").find('.meter-value').css('width', tic__count + "%");
                $("#tic__meter").find('.meter-text').text(tic__count + "%");
                if (tic__count == perc) {
                    clearInterval(tic__inter);
                    tic__meterrunning = false;
                    deadlineAnimation = false;
                }
            }
            tic__inter = setInterval(tic__run, 2);
        }
    }
}

// ------------------- CHANGE OPERATOR ----------------------------

function LoadServiceOperators(ddl, serviceId, ticketType, supportLine, selectedUserProviderKey, addQueueItem) {
    ddl.empty();
    $(document.createElement('option'))
            .attr('value', -1)
            .text(Localization_Loading)
            .appendTo(ddl);

    $.post(
        RQ_URL + '/Tickets/LoadServiceOperators',
        {
            serviceId: serviceId,
            ticketType: ticketType,
            supportLine: supportLine,
            addQueueItem: addQueueItem,
        },
        function (data) {
            ddl.empty();

            if (ddl.data('placeholder')) {
                $('<option/>').appendTo(ddl); //pro Select2 placeholder
            }

            $(data).each(function () {
                var option = $('<option/>', { value: this.Value, 'data-email': this.Email, 'data-domain': this.Domain })
                    .text(this.Text)
                    .appendTo(ddl);

                if (this.Value == selectedUserProviderKey) {
                    option.attr("selected", "selected");
                }
            });
        },
        "json"
        )
        .fail(function (error) { alert(error.responseText); });
}

// ------------------- CONVERT END-USER TICKET (TIC) -------------------------

function LoadServicesForChangingTicketType(selectedId, ticketType) {
    var ddlChangeTicketTypeService = $('#ddlChangeTicketTypeService');
    ddlChangeTicketTypeService.empty();
    $(document.createElement('option'))
            .attr('value', -1)
            .text(Localization_Loading)
            .appendTo(ddlChangeTicketTypeService);

    $("#changeTicketTypeServiceRequired").hide();

    $.post(
        RQ_URL + '/Tickets/LoadServicesForConvertingEndUserTicket',
        { ticketType: ticketType },
        function (data) {
            ddlChangeTicketTypeService.empty();

            var optgroup = null;

            $(data).each(function () {

                if (this.IsDepartment) {
                    optgroup = $(document.createElement('optgroup'))
                        .attr('label', htmlDecode(Array(this.Depth + 1).join("&nbsp;&nbsp;&nbsp;&nbsp;")) + this.Name)
                        .appendTo(ddlChangeTicketTypeService);
                }
                else {
                    var option = $(document.createElement('option'))
                        .attr('value', this.Id)
                        .attr('title', this.Description)
                        .html(Array(this.Depth).join("&nbsp;&nbsp;&nbsp;&nbsp;") + htmlEncode(this.Name));

                    if (this.Id == selectedId)
                        option.attr("selected", "selected");

                    option.appendTo(optgroup !== null ? optgroup : ddlChangeTicketTypeService);
                }

            });
        },
        "json"
        )
        .fail(function (error) { alert(error.responseText); });
}


function ShowTicketTypeChangeFromTicDialog(serviceId, ticketAction) {
    var targetType = ticketAction == 'TicketConvertToServiceRequest' ? 'ServiceRequest' : 'Incident';

    LoadServicesForChangingTicketType(serviceId, targetType);

    var title = ticketAction == 'TicketConvertToServiceRequest' ? Localization_ConvertToREQ : Localization_ConvertToINC;
    $("#dialog-changeTicketType-fromTIC").data('ticket-action', ticketAction);
    $("#dialog-changeTicketType-fromTIC").dialog('option', 'title', title);
    $("#dialog-changeTicketType-fromTIC").dialog("open");
}


// ------------------- CHANGE RISK CATEGORY --------------------

function setRiskCategory_changeRiskCategory(probability, impact) {
    if (probability === null) { probability = 4 - $("#sliderProbability-changeRiskCategory").slider("value"); }
    if (impact === null) { impact = 4 - $("#sliderImpact-changeRiskCategory").slider("value"); }

    var riskCategory = probability + impact - 1;
    $("#riskCategory-changeRiskCategory").html('R' + riskCategory);
    var text;
    switch (riskCategory) {
        case 1: text = Localization_RiskCategoryCritical;
            break;
        case 2: text = Localization_RiskCategoryHigh;
            break;
        case 3: text = Localization_RiskCategoryMedium;
            break;
        case 4: text = Localization_RiskCategoryLow;
            break;
        case 5: text = Localization_RiskCategoryVeryLow;
            break;
        default: text = "UNKNOWN";
            break;
    }

    $("#riskCategoryText-changeRiskCategory").html(text);

    $("#hiddenChangeRiskCategoryProbability").val(probability);
    $("#hiddenChangeRiskCategoryImpact").val(impact);

    var tdTicketRiskCategory = $("#tdTicketRiskCategory-changeRiskCategory");
    tdTicketRiskCategory.removeClass();
    tdTicketRiskCategory.addClass('ticket-priority-' + riskCategory);
}


// ------------------- TINY MCE -----------------------------------

var keypressed = 0;

function InitSendToEmailTinyMCE() {
    tinymce.init({
        selector: '#tbSendToEmailBody',
        cache_suffix: "?ver=" + ver,
        theme: "silver",
        content_css: RQ_URL + '/Content/tiny_mce.css?ver=2',
        entity_encoding: "raw",
        convert_fonts_to_spans: true,
        paste_data_images: false,
        language: language,
        branding: false,
        contextmenu: false,
    });
}

function SaveMessageDrafts() {
    SaveMessageDraft('tbMessage');
    SaveMessageDraft('tbMessageViaEmail');
}

function SaveMessageDraft(id) {
    if (keypressed > 0 && $('#' + id).length) {
        var tinymcemessage = window.tinyMCE.get(id).getContent();

        if (tinymcemessage !== null) {
            var tinemcemessageWithoutP = $.trim(tinymcemessage.replace(/<p>/gi, '').replace(/<\/p>/gi, ''));

            if (!isNullOrWhiteSpace(tinemcemessageWithoutP)) {

                var viaEmail = id == 'tbMessageViaEmail';
                var iconSelector = '.message-save-icon[data-id="' + id + '"]';

                $.post(
                    RQ_URL + '/Tickets/SaveMessageDraft',
                    { ticketId: ticketId, viaEmail: viaEmail, message: tinymcemessage }
                )
                    .done(function () {
                        $(iconSelector + ':not(.success)').hide();
                        $(iconSelector + '.success').show();
                        setTimeout(function () { AnimateRotateOnce(iconSelector + '.success'); }, 100); //musi se nejdriv zviditelnit, aby udelal animaci
                    })
                    .fail(function (error) {
                        console.log(Localization_DraftSavingError);
                        $(iconSelector + ':not(.error)').hide();
                        $(iconSelector + '.error').show();
                    });
            }
        }
    }
}

function ClearMessageDraft(id) {
    $.post(
        RQ_URL + '/Tickets/ClearMessageDraft',
        {
            ticketId: ticketId,
            viaEmail: id === 'tbMessageViaEmail'
        }
    )
    .fail(function (error) { console.log("ClearMessageDraft error"); })
    .done(function () { });
}


function OnTinyMceInit(id) {
    if (id === "tbMessage") {
        //LoadMessageDraft();
        MarkMessageAsPrivate(privateMessage, false); //aby to pri nacteni stranky nefocuslo Tiny s odrollovanim
    } /*else if (id === "tbMessageViaEmail") {
    }*/
}

function isNullOrWhiteSpace(str) {
    return str === null || str.match(/^ *$/) !== null;
}




// ------------------- UPLOADER -----------------------------------
var uploader;
var uploaderViaEmail;

function InitUploader(identifierForAsyncAttachments) {

    uploader = new plupload.Uploader({
        runtimes: 'html5,flash,silverlight',
        url: RQ_URL + '/Tickets/UploadAttachmentAjax',
        browse_button: 'pickfiles',
        container: 'containerAttachments',
        drop_element: "containerdroppable",
        max_file_size: '100mb',
        chunk_size: '1mb',
        unique_names: false,
        multiple_queues: false,
        flash_swf_url: RQ_URL + '/Scripts/plupload/Moxie.swf',
        silverlight_xap_url: RQ_URL + '/Scripts/plupload/Moxie.xap',
        dragdrop: true,
        multipart_params: { identifierForAsyncAttachments: identifierForAsyncAttachments }
    });

    uploader.bind('Init', function (up, params) {
        $('#filelist').html("<ul id=\"filelistul\"></ul>");
    });

    uploader.init();

    uploader.bind('FilesAdded', function (up, files) {
        $.each(files, function (i, file) {
            $('#filelistul').append(
            '<li id="liFile' + file.id + '" class="text-with-hiding-buttons">' +
            '<span>' + file.name + ' <em>(' + formatSize(file.size) + ')</em></span> <b></b><a class="hiddenButton delete" href="javascript:void(0);" onclick="javascript:uploader.removeFile(uploader.getFile(\'' + file.id + '\')); $(\'#liFile' + file.id + '\').remove();" title="' + Localization_Remove + '"><i class="fa fa-times"></i></a>' +
            '</li>');
        });

        up.refresh(); // Reposition Flash/Silverlight
    });

    uploader.bind('UploadProgress', function (up, file) {
        $('#liFile' + file.id + " b").html(file.percent + "%");
    });

    uploader.bind('Error', function (up, err) {
        if (err.code == -600)
            $('#filelist').append('<div class="valid-error">' + Localization_Error + ': ' + Localization_FileSizeIsGreaterThan + ' 100 MB' + (err.file ? ', ' + Localization_File + ': ' + err.file.name : "") + '</div>');
        else
            $('#filelist').append('<div class="valid-error">' + Localization_Error + ': ' + err.code + ', ' + Localization_Message + ': ' + err.message + (err.file ? ', ' + Localization_File + ': ' + err.file.name : "") + '</div>');

        up.refresh(); // Reposition Flash/Silverlight
    });

    var total_upload_files = 0;

    uploader.bind('QueueChanged', function (up, files) {
        total_upload_files = uploader.files.length;
    });

    uploader.bind('FileUploaded', function (up, file) {
        $('#liFile' + file.id + " b").html("100%");
        total_upload_files--;

        if (total_upload_files == 0) {
            $("#ticketViewForm").submit();
        }
    });
}

function InitUploaderViaEmail(identifierForAsyncAttachments) {

    uploaderViaEmail = new plupload.Uploader({
        runtimes: 'html5,flash,silverlight',
        url: RQ_URL + '/Tickets/UploadAttachmentAjax',
        browse_button: 'pickfilesViaEmail',
        container: 'containerAttachmentsViaEmail',
        drop_element: "containerdroppableViaEmail",
        max_file_size: '100mb',
        chunk_size: '1mb',
        unique_names: false,
        multiple_queues: false,
        flash_swf_url: RQ_URL + '/Scripts/plupload/Moxie.swf',
        silverlight_xap_url: RQ_URL + '/Scripts/plupload/Moxie.xap',
        dragdrop: true,
        multipart_params: { identifierForAsyncAttachments: identifierForAsyncAttachments }
    });

    uploaderViaEmail.bind('Init', function (up, params) {
        $('#filelistViaEmail').html("<ul id=\"filelistViaEmailul\"></ul>");
    });

    uploaderViaEmail.init();

    uploaderViaEmail.bind('FilesAdded', function (up, files) {
        $.each(files, function (i, file) {
            $('#filelistViaEmailul').append(
                '<li id="liFile' + file.id + '" class="text-with-hiding-buttons">' +
                '<span>' + file.name + ' <em>(' + formatSize(file.size) + ')</em></span> <b></b><a class="hiddenButton delete" href="javascript:void(0);" onclick="javascript:uploaderViaEmail.removeFile(uploaderViaEmail.getFile(\'' + file.id + '\')); $(\'#liFile' + file.id + '\').remove();" title="' + Localization_Remove + '"><i class="fa fa-times"></i></a>' +
                '</li>');
        });

        up.refresh(); // Reposition Flash/Silverlight
    });

    uploaderViaEmail.bind('UploadProgress', function (up, file) {
        $('#liFile' + file.id + " b").html(file.percent + "%");
    });

    uploaderViaEmail.bind('Error', function (up, err) {
        if (err.code == -600)
            $('#filelistViaEmailul').append('<div class="valid-error">' + Localization_Error + ': ' + Localization_FileSizeIsGreaterThan + ' 100 MB' + (err.file ? ', ' + Localization_File + ': ' + err.file.name : "") + '</div>');
        else
            $('#filelistViaEmailul').append('<div class="valid-error">' + Localization_Error + ': ' + err.code + ', ' + Localization_Message + ': ' + err.message + (err.file ? ', ' + Localization_File + ': ' + err.file.name : "") + '</div>');

        up.refresh(); // Reposition Flash/Silverlight
    });

    var total_upload_files = 0;

    uploaderViaEmail.bind('QueueChanged', function (up, files) {
        total_upload_files = uploaderViaEmail.files.length;
    });

    uploaderViaEmail.bind('FileUploaded', function (up, file) {
        $('#liFile' + file.id + " b").html("100%");
        total_upload_files--;

        if (total_upload_files == 0) {
            $("#ticketViewForm").submit();
        }
    });
}

function formatSize(bytes) {
    if (bytes < 10 * 1024)
        return bytes + "&nbsp;B";
    else if (bytes < 10 * 1024 * 1024)
        return Math.round(bytes / 1024) + "&nbsp;kB";
    else
        return Math.round(bytes / 1024 / 1024) + "&nbsp;MB";
}


// ------------------- MESSAGE ------------------------------------

function AddMessage() {
    if (ValidateMessage()) {
        $("#add-message-public, #add-message-private").attr("disabled", "disabled");
        $('#pickfiles').css({ visibility: "hidden" });
        $('#hiddenMessage').val(window.tinyMCE.get('tbMessage').getContent());
        $('#hiddenActionTicketView').val('addmessage');
        $('#hiddenMessageAsSubmitter').val($('#cbMessageAsSubmitter').is(':checked') ? 'True' : 'False');
        $('#cbMessageAsSubmitter').prop('checked', false);

        if (uploader.files.length > 0) {
            $('#filelist div[id^="liFile"] a').remove(); //@*da pryc [Remove] *@
            OnAjaxBegin();
            uploader.start();
        }
        else
            $("#ticketViewForm").submit();
    }
    else {
        $("#add-message-public, #add-message-private").one("click", function () { AddMessage(); }); //rebind one
        //return false; //@*zrusit odeslani validace pokud neprojde explicitni validace*@
    }
}

function AddMessageViaEmail() {
    if (ValidateMessageViaEmail()) {
        $("#add-message-via-email").attr("disabled", "disabled");
        $('#pickfilesViaEmail').css({ visibility: "hidden" });
        $('#hiddenMessage').val(window.tinyMCE.get('tbMessageViaEmail').getContent());
        $('#hiddenActionTicketView').val('addmessage');

        if (uploaderViaEmail.files.length > 0) {
            $('#filelistViaEmail div[id^="liFile"] a').remove(); //@*da pryc [Remove] *@
            OnAjaxBegin();
            uploaderViaEmail.start();
        }
        else
            $("#ticketViewForm").submit();
    }
    else {
        $("#add-message-via-email").one("click", function () { AddMessageViaEmail(); });
        //return false; //@*zrusit odeslani validace pokud neprojde explicitni validace*@
    }
}

function ValidateMessage(viaEmail) {
    var isMessageValid = window.tinyMCE.get('tbMessage').getContent().length > 0;
    $('#spanMessageRequired').toggle(!isMessageValid);
    return isMessageValid;
}

function ValidateMessageViaEmail() {
    var isMessageValid = window.tinyMCE.get('tbMessageViaEmail').getContent().length > 0;
    $('#spanMessageViaEmailRequired').toggle(!isMessageValid);
    return isMessageValid;
}

//function QuoteMessage(id, private = false) { //nelze v IE
function QuoteMessage(id, isPrivate) {
    isPrivate = isPrivate || false; //protoze tam neni ten default, tak takhle

    var body = $('#message-id' + id).html();
    var fullname = $('#message-fullname' + id).html();
    body = '<p></p><div class="quote">-- ' + fullname + ': --\r\n' + body + '</div><p></p>';
    //window.tinyMCE.get('tbMessage').setContent(body);

    window.tinyMCE.get('tbMessage').execCommand('mceInsertContent', false, body);
    
    if (!$('#newMessageFull').is(':visible')) {
        SwitchNewMessageToFullMode();
    }

    var offset = $("#liNewMessage").offset().top - 85;

    $('html,body').animate({
        scrollTop: offset
    });

    SwitchToComment(isPrivate);
}

function ReplyMessage(id) {
    var editor = window.tinyMCE.get('tbMessageViaEmail');
    editor.selection.collapse();
    $(editor.dom.doc).find('#divHistoryButton').remove();
    $(editor.dom.doc).find('.js-history-content').remove();

    OnAjaxBegin();
    $.get(
        RQ_URL + "/Tickets/GetMessageBodyForEmailReply",
        {
            messageId: id,
        },
        function (data) {
            $(editor.dom.doc).find('body').append('<div class="js-history-content" style="display: block;">' + data + '</div>'); //js-history-content - priprava na remove a sjednoceni s odkrytou historii manualne
        },
        "html"
    )
    .done(function () {
        OnAjaxComplete();
    });


    if (!$('#newMessageFull').is(':visible')) {
        SwitchNewMessageToFullMode();
    }

    var offset = $("#liNewMessage").offset().top - 85;

    $('html,body').animate({
        scrollTop: offset
    });

    SwitchToEmail();
}

function ShowSplitTicketDialog(ticketMessageId) {
    $("#dialog-confirm-split-ticket").dialog('option', 'buttons', {}).dialog('open');
    $("#dialog-confirm-split-ticket-content").empty();
    $("#dialog-confirm-split-ticket-content").addClass('loading-32');

    $("#dialog-confirm-split-ticket-content").load(RQ_URL + "/Tickets/SplitTicketPartial", { ticketId: ticketId, ticketMessageId: ticketMessageId }, function (response, status, xhr) {
        $("#dialog-confirm-split-ticket-content").removeClass('loading-32');

        if (status != "error") {
            $("#dialog-confirm-split-ticket").dialog('close');
            $("#dialog-confirm-split-ticket").dialog('open'); //recenter
        }
        else {
            alert(xhr.status + " " + xhr.statusText);
        }
    });
}


// ------------------- EDIT MESSAGE IN SITUM ----------------------

function EditMessage(id) {
    $('#message-id' + id).find('button.show-requestor-quote').remove();
    $('#hidden-message-id' + id).val($('#message-id' + id).html().trim());

    //$('#edit-id' + id).hide();
    //$('#quote-id' + id).hide();
    //$('#forward-id' + id).hide();
    //$('#delete-id' + id).hide();
    $('#message-actions-id' + id).hide();
    $('#save-cancel-id' + id).show();

    tinymce.init({
        selector: '#message-id' + id,
        cache_suffix: "?ver=" + ver,
        theme: "silver",
        plugins: ["emoticons preview paste autolink autoresize code image searchreplace lists link charmap visualblocks fullscreen nonbreaking hr insertdatetime textpattern media"],
        content_css: RQ_URL + '/Content/tiny_mce.css?ver=2',
        toolbar: "bold italic underline strikethrough | styleselect | forecolor backcolor | bullist numlist | link unlink | image code preview blockquote | preparedReply" + (userHasAccessToKnowledgeBase ? " knowledge" : ""),
        menubar: false,
        entity_encoding: "raw",
        convert_fonts_to_spans: true,
        paste_data_images: true,
        language: language,
        branding: false,
        contextmenu: false,
        browser_spellcheck: true,
        auto_focus: "message-id" + id,
        setup: function (ed) {
            if (userHasAccessToKnowledgeBase) {
                ed.ui.registry.addButton('knowledge', {
                    text: Localization_Knowledge,
                    onAction: function (buttonApi) {
                        textareaId = 'message-id' + id; // nastavení pro partial
                        OnAjaxBegin(Localization_Loading);
                        $("#divForDialogForKnowledgeBase").empty();
                        $("#divForDialogForKnowledgeBase").load(RQ_URL + '/KnowledgeBase/PartialDialogKnowledgeBaseForTicket', function () { OnAjaxComplete(); });
                    }
                });
            }
        }
    });


    window['uploaderidasync' + id] = (Math.floor(Math.random() * 1000000000)).toString(); //random number string as id
    window['uploader' + id] = new plupload.Uploader({
        runtimes: 'html5,flash,silverlight',
        url: RQ_URL + '/Tickets/UploadAttachmentAjax',
        browse_button: 'pickfiles' + id,
        container: 'containerAttachments' + id,
        drop_element: "containerdroppable" + id,
        max_file_size: '100mb',
        chunk_size: '1mb',
        unique_names: false,
        multiple_queues: false,
        multipart_params: { identifierForAsyncAttachments: window['uploaderidasync' + id] },
        flash_swf_url: RQ_URL + '/Scripts/plupload/Moxie.swf")',
        silverlight_xap_url: RQ_URL + '/Scripts/plupload/Moxie.xap")',
        dragdrop: true
    });

    window['uploader' + id].bind('Init', function (up, params) {
        //$('#filelist').html("<div>Current runtime: " + params.runtime + "</div>");
        $('#filelist' + id).html("");
    });

    window['uploader' + id].init();

    window['uploader' + id].bind('FilesAdded', function (up, files) {
        $.each(files, function (i, file) {
            $('#filelist' + id).append(
                '<div id="divFile' + id + file.id + '" class="text-with-hiding-buttons">' +
                '<span>' + file.name + ' <em>(' + plupload.formatSize(file.size) + ')</em></span> <b></b><a class="hiddenButton delete" href="javascript:void(0);" onclick="javascript:window[\'uploader\' + ' + id + '].removeFile(window[\'uploader\' + ' + id + '].getFile(\'' + file.id + '\')); $(\'#divFile' + id + file.id + '\').remove();" title="' + Localization_Remove + '"><i class="fa fa-times"></i></a>' +
                '</div>');
        });

        up.refresh(); // Reposition Flash/Silverlight
    });

    window['uploader' + id].bind('UploadProgress', function (up, file) {
        $('#divFile' + id + file.id + " b").html(file.percent + "%");
    });

    window['uploader' + id].bind('Error', function (up, err) {
        if (err.code == -600)
            $('#filelist' + id).append('<div class="valid-error">' + Localization_Error + ': ' + Localization_FileSizeIsGreaterThan + ' 100 MB' + (err.file ? ', ' + Localization_File + ': ' + err.file.name : "") + '</div>');
        else
            $('#filelist' + id).append('<div class="valid-error">' + Localization_Error + ': ' + err.code + ', ' + Localization_Message + ': ' + err.message + (err.file ? ', ' + Localization_File + ': ' + err.file.name : "") + '</div>');

        up.refresh(); // Reposition Flash/Silverlight
    });

    window['total_upload_files' + id] = 0;

    window['uploader' + id].bind('QueueChanged', function (up, files) {
        window['total_upload_files' + id] = window['uploader' + id].files.length;
    });

    window['uploader' + id].bind('FileUploaded', function (up, file) {
        $('#divFile' + id + file.id + " b").html("100%");
        window['total_upload_files' + id]--;

        if (window['total_upload_files' + id] == 0) {
            //$('#containerAttachments' + id).hide();
            window['uploader' + id].destroy();

            $.post( //finish atts save
                RQ_URL + '/Tickets/SaveAttachments',
                { messageId: id, tempAttDirId: window['uploaderidasync' + id] },
                function (data) {
                    if (!data.result) {
                        alert("Attachments cannot be saved.");
                    }
                    else {
                        $(data.htmlAtts).each(function () {
                            $('#attOthers' + id).append('<span id="attachment-guid' + this.fileNameGuid + '">' + ($('#attOthers' + id + ' > span').length > 0 ? ' | ' : '') + this.htmlAtt + '</span>');
                            $('#ulAttachments').append(this.htmlAttRightPanel);
                        });
                    }
                },
                "json"
            )
                .fail(function (error) { alert(error.responseText); })
                .done(function () {
                    $('#containerAttachments' + id).hide();
                    SaveMessage(id, true);                    
                })
                .always(function () { OnAjaxComplete(); });

        }
    });

    $('#containerAttachments' + id).show();

}

function CancelEditMessage(id) {
    if (window.tinyMCE.get('message-id' + id)) {
        window.tinymce.execCommand('mceFocus', false, 'message-id' + id);
        window.tinymce.execCommand('mceRemoveEditor', false, 'message-id' + id);
    }

    $('#message-id' + id).html($('#hidden-message-id' + id).val());
    $('#save-cancel-id' + id).hide();
    //$('#edit-id' + id).show();
    //$('#quote-id' + id).show();
    //$('#forward-id' + id).show();
    //$('#delete-id' + id).show();
    $('#message-actions-id' + id).show();

    $('#containerAttachments' + id).hide();

    window['uploader' + id].destroy();
}

function SaveMessage(id, forcesavemessage) {
    if (window['uploader' + id].files.length > 0 && !forcesavemessage) { //start plupload
        $('#filelist' + id + ' div[id^="divFile' + id + '"] a').remove(); //@*da pryc [Remove] *@
        OnAjaxBegin();
        window['uploader' + id].start();
    }
    else { //save messave text
        tinyMCE.triggerSave();
        var message = $('#message-id' + id).html();
        var messageBeforeEdit = $('#hidden-message-id' + id).val();

        if (message.trim().length == 0) {
            alert('Zpráva nemůže být prázdná');
            return;
        }

        if (messageBeforeEdit != message || forcesavemessage) {
            OnAjaxBegin();

            $.post(
                RQ_URL + '/Tickets/EditMessage',
                { messageId: id, body: message, connectionId: $.connection.hub.id },
                function (data) {
                    if (!data.result) {
                        alert(Localization_MessageCannotBeEdited);
                    }
                    else {
                        $("#message-edited-date" + id).html(data.datetime);
                    }
                },
                "json"
            )
                .fail(function (error) { alert(error.responseText); })
                .done(function () {
                    if ($("#message-original-id" + id).html().trim().length == 0) {
                        $("#message-original-id" + id).html(messageBeforeEdit);
                        $("#message-edited" + id).show();
                    }

                    //nove se to prepise ajaxem, aby editovana zprava byla presne (chybel treba nahled obrazku)
                    RefreshTicketUserMessageAjax(id);

                })
                .always(function () { OnAjaxComplete(); });        
        }

        if (window.tinyMCE.get('message-id' + id)) {
            window.tinymce.execCommand('mceFocus', false, 'message-id' + id);
            window.tinymce.execCommand('mceRemoveEditor', false, 'message-id' + id);
        }

        $('#save-cancel-id' + id).hide();
        $('#containerAttachments' + id).hide();
        $('#message-actions-id' + id).show();
    }
}

function DeleteMessage(id) {
    $("#dialog-confirm-delete-message").dialog({
        autoOpen: true,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [
            {
                text: Localization_Yes,
                click: function () {
                    $(this).dialog("close");

                    $('#message-id' + id).text('-');

                    $.post(
                        RQ_URL + '/Tickets/DeleteMessage',
                        { messageId: id, connectionId: $.connection.hub.id },
                        function (data) {
                            if (!data.result) {
                                alert('Message cannot be deleted.');
                            }
                        },
                        "json"
                    )
                        .fail(function (error) { alert(error.responseText); })
                        .done(function () {
                            RefreshTicketUserMessageAjax(id);
                        });
                }
            },
            {
                text: Localization_No,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });
}

function ShowMessageOriginal(id) {
    $('#aShowMessageOriginal' + id).hide();
    $('#aHideMessageOriginal' + id).show();
    $('#message-original-id' + id).show('fast');
}

function HideMessageOriginal(id) {
    $('#aHideMessageOriginal' + id).hide();
    $('#aShowMessageOriginal' + id).show();
    $('#message-original-id' + id).hide('fast');
}

function DeleteAttachment(filename, fileguid) {
    $("#confirm-delete-attachment-name").html(filename);

    $("#dialog-confirm-delete-attachment").dialog({
        autoOpen: true,
        resizable: false,
        width: 500,
        height: "auto",
        modal: true,
        buttons: [
            {
                text: Localization_Yes,
                click: function () {
                    $(this).dialog("close");

                    OnAjaxBegin();

                    $.post(
                        RQ_URL + '/Tickets/DeleteAttachment',
                        { fileNameGuid: fileguid },
                        function (data) {
                            if (!data.result) {
                                alert(Localization_AttachmentCannotBeDeleted);
                            }
                            else {
                                $("#attachment-guid" + fileguid).remove();
                                $("#li-attachment-guid" + fileguid).remove();
                            }
                        },
                        "json"
                    )
                        .fail(function (error) { alert(error.responseText); })
                        .done(function () { })
                        .always(function () { OnAjaxComplete(); });                   
                }
            },
            {
                text: Localization_No,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });
}



// ------------------- MANAGER BOX --------------------------------

function DeleteTicket() {
    $("#dialog-confirm-delete-ticket").dialog({
        autoOpen: true,
        resizable: false,
        width: 500,
        height: "auto",
        modal: true,
        buttons: [
            {
                text: Localization_Yes,
                click: function () {
                    $(this).dialog("close");
                    $('#hiddenActionTicketView').val('deleteticket');
                    $("#ticketViewForm").submit();
                }
            },
            {
                text: Localization_No,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });
}

function CloseTicket() {
    $("#dialog-confirm-close-ticket").dialog({
        autoOpen: true,
        resizable: false,
        width: 500,
        height: "auto",
        modal: true,
        buttons: [
            {
                text: Localization_Yes,
                click: function () {
                    $(this).dialog("close");
                    $('#hiddenActionTicketView').val('closeticket');
                    $("#ticketViewForm").submit();
                }
            },
            {
                text: Localization_No,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });
}

// ------------------- CUSTOM FIELDS ------------------------------

// ------------------- TICKET INVITATIONS -------------------------


function DeleteTicketInvitation(id) {
    $("#dialog-confirm-delete-ticketinvitation").dialog({
        autoOpen: true,
        resizable: false,
        width: 500,
        height: "auto",
        modal: true,
        buttons: [
            {
                text: Localization_Yes,
                click: function () {
                    $(this).dialog("close");
                    $('#hiddenActionTicketView').val('removeuserfrominvited');
                    $("#hiddenTicketInvitationIdRemove").val(id);
                    $("#ticketViewForm").submit();
                }
            },
            {
                text: Localization_No,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });
}

// ------------------- TICKET MESSAGE TYPE ------------------------
function MarkMessageAsPrivate(isPrivate, focus) {

    if (!$("#liMessageAsComment").hasClass('active'))
        return; //pokud neni vybrana zalozka komentare, tak nic nenastavuju (muze existovat kombinace mail + private message v promennych)

    var maintinymce = window.tinyMCE.get('tbMessage');

    if (isPrivate) {
      
        $(maintinymce.getBody()).css("background-color", '#fefef0');
        $(maintinymce.getBody().parentNode).css("background-color", '#fefef0');

        if (!$('#rbPrivateMessage').is(':checked')) {
            $('#rbPrivateMessage').prop('checked', true);
        }

        $('#cbMessageAsSubmitter').prop('checked', false);
        $('#cbMessageAsSubmitter').prop('disabled', true);
    } else {

        if (!$('#rbPublicMessage').is(':checked')) {
            $('#rbPublicMessage').prop('checked', true);
        }

        $(maintinymce.getBody()).css("background-color", 'white');
        $(maintinymce.getBody().parentNode).css("background-color", 'white');

        $('#cbMessageAsSubmitter').prop('disabled', false);
    }

    $('.btn-group-add-message-public').css('display', !isPrivate ? 'inline-block' : 'none');
    $('.btn-group-add-message-private').css('display', isPrivate ? 'inline-block' : 'none');

    if (focus) {
        window.tinymce.execCommand('mceFocus', false, 'tbMessage');
    }

    privateMessage = isPrivate;
}

function SwitchToEmail() {
    $("#liMessageViaOutboundEmail").addClass('active');
    $("#liMessageAsComment").removeClass('active');
    $('.message-via-comment').hide();
    $('.message-via-outbound-email').show();
    $('#newMessageFull .hint #spanMessageComment').hide();
    $('#newMessageFull .hint #spanMessageEmail').show();
    $('#hiddenMessageViaOutboundEmail').val('True');

    var maintinymce = window.tinyMCE.get('tbMessageViaEmail');
    $(maintinymce.getBody()).css("background-color", 'white');
    $(maintinymce.getBody().parentNode).css("background-color", 'white');
    window.tinymce.execCommand('mceFocus', false, 'tbMessageViaEmail');
}

function SwitchToComment(isPrivate) {
    $("#liMessageAsComment").addClass('active');
    $("#liMessageViaOutboundEmail").removeClass('active');
    $('.message-via-outbound-email').hide();
    $('.message-via-comment').show();
    $('#newMessageFull .hint #spanMessageEmail').hide();
    $('#newMessageFull .hint #spanMessageComment').show();
    $('#hiddenMessageViaOutboundEmail').val('False');
    MarkMessageAsPrivate(isPrivate, true);
}

// ------------------- EDIT CUSTOMFIELDS AND CUSTOM FORMS ------------------
function EditCustomFields() {
    $('#hiddenActionTicketView').val('editcustomfields');
    $("#ticketViewForm").submit();
}

function EditCustomForm(id, bt) {
    $(bt).tooltipBS('destroy');
    $('#hiddenActionTicketView').val('editcustomform');
    $('#hiddenEditCustomFormId').val(id);
    $("#ticketViewForm").submit();
}

function Reload() {
    $('#hiddenActionTicketView').val('reload');
    $("#ticketViewForm").submit();
}

function DeleteVote() {
    var id = $("#Post_TicketId").val();
    $.ajax({
        url: RQ_URL + '/Tickets/DeleteVote?id=' + id,
        type: "GET",
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        cache: false,
    }).done(function (data) {
        if (data > 0) {
            if (!$("#TicketViewCount").hasClass("cursor_pointer")) {
                $("#TicketViewCount").addClass("cursor_pointer");
            }
        }
        else {
            $("#TicketViewCount").removeClass("cursor_pointer");
        }
        $("#TicketVoteDelete").hide();
        $("#TicketVoteAdd").show();
        $("#TicketViewCount").text(data);
    });
}

function AddVote() {
    var id = $("#Post_TicketId").val();
    $.ajax({
        url: RQ_URL + '/Tickets/AddVote?id=' + id,
        type: "GET",
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        cache: false,
    }).done(function (data) {
        if (data > 0) {
            if (!$("#TicketViewCount").hasClass("cursor_pointer")) {
                $("#TicketViewCount").addClass("cursor_pointer");
            }
        }
        else {
            $("#TicketViewCount").removeClass("cursor_pointer");
        }
        $("#TicketVoteDelete").show();
        $("#TicketVoteAdd").hide();
        $("#TicketViewCount").text(data);
    });
}

function LoadVotes() {
    if ($("#TicketViewCount").hasClass("cursor_pointer")) {
        var id = $("#Post_TicketId").val();
        $("#dialog-votes").empty();
        $("#dialog-votes").append("<div class='loading-32'></div>");
        $("#dialog-votes").dialog("open");
        $("#dialog-votes").load(RQ_URL + "/Tickets/VotesForTicket/" + id, function () {
            $("#dialog-votes").dialog("close");
            $("#dialog-votes").dialog("open");
        });
    }
}

function LoadTicketAccessOthers() {
    var id = $("#Post_TicketREF").val();
    $("#dialog-ticket-access-others").empty();
    $("#dialog-ticket-access-others").append("<div class='loading-32'></div>");
    $("#dialog-ticket-access-others").dialog("open");
    $("#dialog-ticket-access-others").load(RQ_URL + "/Tickets/GetTicketAccessOthers/" + id, function () {
        $("#dialog-ticket-access-others").dialog("close");
        $("#dialog-ticket-access-others").dialog("open");
    });
}

function LoadTicketInvitationsQueue() {
    var id = $("#Post_TicketREF").val();
    $("#dialog-ticket-invitations").empty();
    $("#dialog-ticket-invitations").append("<div class='loading-32'></div>");
    $("#dialog-ticket-invitations").dialog("open");
    $("#dialog-ticket-invitations").load(RQ_URL + "/Tickets/GetTicketInvitations/" + id, function () {
        $("#dialog-ticket-invitations").dialog("close");
        $("#dialog-ticket-invitations").dialog("open");
    });
}

function LoadTicketOperatorsQueue() {
    var id = $("#Post_TicketREF").val();
    $("#dialog-ticket-operators-queue").empty();
    $("#dialog-ticket-operators-queue").append("<div class='loading-32'></div>");
    $("#dialog-ticket-operators-queue").dialog("open");
    $("#dialog-ticket-operators-queue").load(RQ_URL + "/Tickets/GetTicketOperatorsQueue/" + id, function () {
        $("#dialog-ticket-operators-queue").dialog("close");
        $("#dialog-ticket-operators-queue").dialog("open");
    });
}

function RefreshTicketUserMessageAjax(id, animate) {
    $.ajax({
        url: RQ_URL + '/Tickets/PartialTicketUserMessage?ticketId=' + ticketId + '&ticketMessageId=' + id,
        type: "GET",
        dataType: "html",
        contentType: "application/json; charset=utf-8",
        cache: false,
    }).done(function (data) {
        var $oldli = $('div.timeline div.comment[data-id=' + id + ']');

        if ($oldli.length != 0) {
            var $newli = $(data);
            $oldli.after($newli);
            $oldli.remove();
            $newli.show();

            if (animate) {
                $newli.addClass('animated pulse');
                $newli.find('.timeline-panel').addClass('async');
            }

            InitShowEmailQuoteButtons('div.timeline div.comment[data-id=' + id + '] .communication-comment');
        }      
        
    }).fail(function (error) {
        { alert(error.responseText); }
    });
}

function RefreshTicketStickyNoteAjax(ticketStickyNoteId, animate) {
    $.ajax({
        url: RQ_URL + '/Tickets/PartialTicketStickedNote?ticketId=' + ticketId + '&ticketStickyNoteId=' + ticketStickyNoteId,
        type: "GET",
        dataType: "html",
        contentType: "application/json; charset=utf-8",
        cache: false,
    }).done(function (data) {
        var $olddiv = $('.ticket-sticky-notes .ticket-sticky-note[data-id=' + ticketStickyNoteId + ']');

        if ($olddiv.length != 0) {
            var $newdiv = $(data);
            $olddiv.after($newdiv);
            $olddiv.remove();
            $newdiv.show();

            if (animate) {
                $newdiv.addClass('animated pulse');
                $newdiv.find('.timeline-panel').addClass('async');
            }
        }
    }).fail(function (error) {
        alert(error.responseText);
    });
}

function showSalesForceDetail(submitterKey, customerName) {
    $("#SubmitterBoxSalesForce").html("<div class='loading-32'></div>")
    $("#SubmitterBoxSalesForce").load(RQ_URL + "/Applications/TableSalesForce?submitterKey=" + submitterKey + "&customerName=" + encodeURIComponent(customerName), function (response, status, xhr) {
        if (status == "error") {
            alert(response);
        }
    });
}

function TicketNavigate(relative) {

    var viewId = $('#hiddenViewId').val();
    var sortBy = $('#hiddenSortBy').val();
    var sortByDesc = $('#hiddenSortByDesc').val();
    var archive = $('#hiddenArchive').val();

    OnAjaxBegin();

    $.post(
        RQ_URL + '/Tickets/LoadTicketNavigation',
        {
            viewId: viewId != '' ? viewId : null,
            sortBy: sortBy != '' ? sortBy : null,
            sortByDesc: sortByDesc != '' ? sortByDesc == 'True' : null,
            id: ticketId,
            archive: archive == 'True',
            move: relative,
        },
        function (data) {

            if (data.RedirectToTicketList)
                window.location.href = RQ_URL + '/Tickets/List';
            else {
                var urlParams = $.param({ viewId: data.ViewId, sortBy: data.SortBy, sortByDesc: data.SortByDesc });

                if (relative == -1) {
                    if (data.ShowPrevious)
                        window.location.href = RQ_URL + '/Tickets/Show/' + data.PreviousTicketId + '?' + urlParams;
                    else {
                        $('#js-ticket-navigation-previous').prop('disabled', true);
                        OnAjaxComplete();
                    }

                }
                else if (relative == +1) {
                    if (data.ShowNext)
                        window.location.href = RQ_URL + '/Tickets/Show/' + data.NextTicketId + '?' + urlParams;
                    else {
                        $('#js-ticket-navigation-next').prop('disabled', true);
                        OnAjaxComplete();
                    }
                }

                $('#lbTicketNavigationCurrentPosition').text(data.CurrentPosition);
                $('#lbTicketNavigationTotalCount').text(data.TotalCount);

                $('#ticket-navigation-numbers').addClass("inline");
            }
        },
        "json"
    )
        .fail(function (error) { OnAjaxComplete(); alert(error.responseText); })
        .done(function () { })
        .always(function () { });
}

function ClearTicketNavigation() {
    if (typeof (Storage) !== "undefined") {
        sessionStorage.removeItem('TicketNavigation');
    }
}

function SwitchNewMessageToFullMode() {
    $('#newMessageCompact').hide();
    $('#newMessageFull').show();
}

function SwitchNewMessageToCompactMode() {
    $('#newMessageFull').hide();
    $('#newMessageCompact').show();
}


// ------------------- FORWARD EMAIL UPLOADER -----------------------------------
var forwardEmailUploader;

function InitForwardEmailUploader(identifierForAsyncAttachments) {

    forwardEmailUploader = new plupload.Uploader({
        runtimes: 'html5,flash,silverlight',
        url: RQ_URL + '/Tickets/UploadAttachmentAjax',
        browse_button: 'email-forward-pickfiles',
        container: 'email-forward-containerAttachments',
        /*drop_element: "email-forward-containerdroppable",*/ //#drag_drop_dialog_failure
        max_file_size: '10mb',
        chunk_size: '1mb',
        unique_names: false,
        multiple_queues: false,
        multipart_params: { identifierForAsyncAttachments: identifierForAsyncAttachments },
        flash_swf_url: RQ_URL + '/Scripts/plupload/Moxie.swf',
        silverlight_xap_url: RQ_URL + '/Scripts/plupload/Moxie.xap',
        /*dragdrop: true*/ //#drag_drop_dialog_failure
    });

    forwardEmailUploader.bind('Init', function (up, params) {
        $('#email-forward-filelist').html("<ul id=\"email-forward-filelistul\"></ul>");
    });

    forwardEmailUploader.init();

    forwardEmailUploader.bind('FilesAdded', function (up, files) {
        $.each(files, function (i, file) {
            $('#email-forward-filelistul').append(
            '<li id="liFile' + file.id + '" class="text-with-hiding-buttons">' +
            '<span>' + file.name + ' (' + formatSize(file.size) + ')</span> <b></b><a class="hiddenButton delete" href="javascript:void(0);" onclick="javascript:forwardEmailUploader.removeFile(forwardEmailUploader.getFile(\'' + file.id + '\')); $(\'#liFile' + file.id + '\').remove();" title="' + Localization_Remove + '"><i class="fa fa-times"></i></a>' +
            '</li>');
        });

        up.refresh(); // Reposition Flash/Silverlight
    });

    forwardEmailUploader.bind('UploadProgress', function (up, file) {
        $('#email-forward-filelistul #liFile' + file.id + " b").html(file.percent + "%");
    });

    forwardEmailUploader.bind('Error', function (up, err) {
        if (err.code == -600)
            $('#email-forward-filelist').append('<div class="valid-error">' + Localization_Error + ': ' + Localization_FileSizeIsGreaterThan + ' 10 MB' + (err.file ? ', ' + Localization_File + ': ' + err.file.name : "") + '</div>');
        else
            $('#email-forward-filelist').append('<div class="valid-error">' + Localization_Error + ': ' + err.code + ', ' + Localization_Message + ': ' + err.message + (err.file ? ', ' + Localization_File + ': ' + err.file.name : "") + '</div>');

        up.refresh(); // Reposition Flash/Silverlight
    });

    var total_upload_files = 0;

    forwardEmailUploader.bind('QueueChanged', function (up, files) {
        total_upload_files = forwardEmailUploader.files.length;
    });

    forwardEmailUploader.bind('FileUploaded', function (up, file) {
        $('#liFile' + file.id + " b").html("100%");
        total_upload_files--;

        if (total_upload_files == 0) {
            ForwardEmail();
        }
    });
}


// ------------------- SKRYVANI REPLY TEXTU Z EMAILU ----------------------------

function InitShowEmailQuoteButtons(parent) {
    var $emailQuotes = $(parent + " .requestor-quote");
    var $button = $('<button type="button" class="btn btn-default btn-xs show-requestor-quote" title="show quotet text">...</button>');
    $emailQuotes.before($button);

    $(parent).on("click", "button.show-requestor-quote", function () {
        $div = $(this).next('div.requestor-quote');

        if ($div.is(':hidden')) {
            var messageId = $(this).closest('div.comment').data('id');
            var original = $(this).closest('div.ticket-message-original').length > 0;

            LoadCommentRequestorQuote(messageId, original);
            $div.show();
        }
        else {
            $div.empty(); //Remove all child nodes of the set of matched elements from the DOM.
            $div.hide();
        }

        //$div.slideToggle();

    });
}

function LoadCommentRequestorQuote(messageId, original) {
    var $div = original ? $('div.timeline div.comment[data-id=' + messageId + '] div.ticket-message-original div.requestor-quote') : $('div.timeline div.comment[data-id=' + messageId + '] div:not(.ticket-message-original) div.requestor-quote');
    $div.html('<div class="loading-32 left margin-top"></div>');

    $.ajax({
        url: RQ_URL + '/Tickets/ShowRequestorQuote/' + messageId,
        type: "POST",
        data: JSON.stringify({
            messageId: messageId,
            original: original,
        }),
        dataType: "json",
        contentType: "application/json; charset=utf-8",
    }).done(function (data) {
        $div.html(data);  
    }).fail(function (error) {
        { alert(error.responseText); }
    });   
}

function OpenDialogBoxSettings() {
    $("#dialog-box-settings").dialog("open");
}


function SaveTicketCategories() {
    var categories = $('select.select2TreeCategories');
    var isValid = true;
    $('.category-validation').hide();
    if (categories.length != 0) {

        $.each(categories, function (index, value) {
            if ($(value).data("selectionrequired") == "True" && $(value).val() == "") {
                isValid = false;
                $(value).closest(".js-category").find(".category-validation").show();
            }
        });
    }
    if (!isValid)
        return;

    var $i = $("#btnSaveCategories").find("i");
    $("#btnSaveCategories").find("span").text(Localization_Saved);
    $i.removeClass("fa-floppy-o");
    $i.addClass("fa-check");
    $i.addClass("green");
    $("#btnSaveCategories").attr("disabled", "disabled");
    $(".select2TreeCategories").attr("disabled", "disabled");
    var categoryItems = Array();
    $.each($(".select2TreeCategories"), function (index, value) {
        categoryItems.push({ CategoryId: $(value).data("categoryid"), CategoryItemId: $(value).val() });
    });
    $.ajax({
        url: RQ_URL + "/Tickets/TicketCategories",
        type: "POST",
        data: JSON.stringify({
            id: ticketId,
            categoryItems: categoryItems
        }),
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        error: function (error) { alert(error.responseText); },
        success: function (data) {
            if (data.Success) {
                setTimeout(function () {
                    window.location.reload();
                }, 1000);
            } else {
                $.each(data.CategoryIds, function (index, value) {
                    $("#CategoryError" + value).show();
                    $("#btnSaveCategories").removeAttr("disabled");
                    $(".select2TreeCategories").removeAttr("disabled");
                    $("#btnSaveCategories").find("span").text(Localization_Save);
                });
            }
        }
    });
}

function setReminder(date, time) {
    $.ajax({
        url: RQ_URL + "/Tickets/AddReminder",
        type: "POST",
        data: JSON.stringify({
            id: ticketId,
            date: date,
            time: time
        }),
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        error: function (error) { alert(error.responseText); },
        success: function (data) {
            if (data.Success) {
                ShowSuccess(Localization_ReminderWasSet);
                $("#dialog-select-reminder").dialog("close");
                if (refreshReminderBlockInDialog) {
                    refreshReminderBlockInDialog = false;
                }
                refreshReminderDialogContent();
                $(".js-reminder-button").data("hasreminder", "True");
                $(".js-reminder-button > i").removeClass("gray");
                $(".js-reminder-button > i").removeClass("green");
                $(".js-reminder-button > i").addClass("green");
                $(".js-reminder-button").attr("data-original-title", Localization_Reminder + " " + date + " " + Localization_At + " " + moment.utc(time, "HH:mm").format("LT"));
            }
        }
    });
}

function setPostponedUntil(date, time) {
    $.ajax({
        url: RQ_URL + "/Tickets/SetPostponedUntil",
        type: "POST",
        data: JSON.stringify({
            id: ticketId,
            date: date,
            time: time,
        }),
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        error: function (error) { alert(error.responseText); },
        success: function (data) {
            if ($("#PostponedUntilSetReminder").is(":checked")) {
                setReminder(date, time);
            }
            $("#PostponedUntilText").show();
            $("#PostponedUntilButton").hide();
            $("#PostponeUntilDate").text(date + " " + time);
            $("#dialog-postponed-until-set-time").dialog("close");
            $("#dialog-postponed-until").dialog("close");
        }
    });
}

function removePostponedUntil() {
    $.ajax({
        url: RQ_URL + "/Tickets/RemovePostponedUntil",
        type: "POST",
        data: JSON.stringify({
            id: ticketId
        }),
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        error: function (error) { alert(error.responseText); },
        success: function (data) {
            $("#PostponedUntilText").hide();
            $("#PostponedUntilButton").show();
        }
    });
}


function showSetReminderDialog() {
    $("#dialog-reminder-set-time").dialog({
        autoOpen: true,
        resizable: false,
        width: "500px",
        height: "auto",
        modal: true,
        buttons: [
            {
                text: Localization_Remind,
                click: function () {
                    $("#dialog-reminder-set-time .valid-error").hide();
                    if ($("#TicketReminderDate").val() == "" || $("#TicketReminderTime").val() == "") {
                        $("#dialog-reminder-set-time .valid-error").show();
                    }
                    else {
                        var selectedDate = $("#TicketReminderDate").datepicker('getDate');
                        var now = new Date();
                        var time = $('#TicketReminderTime').timepicker('getTime', new Date()).split(':');
                        selectedDate.setHours(time[0]);
                        selectedDate.setMinutes(time[1]);

                        if(now > selectedDate) {
                            $("#dialog-reminder-set-time .valid-error").show();
                        } else {
                            setReminder($("#TicketReminderDate").val(), $("#TicketReminderTime").val());
                            $(this).dialog("close");
                        }
                    }
                }
            },
            {
                text: Localization_Close,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });
}

function deleteReminider() {
    $.ajax({
        url: RQ_URL + "/Tickets/DeleteReminder",
        type: "POST",
        data: JSON.stringify({
            id: ticketId
        }),
        dataType: "json",
        contentType: "application/json; charset=utf-8",
        error: function (error) { alert(error.responseText); },
        success: function (data) {
            ShowSuccess(Localization_ReminderWasDeleted);
            $(".js-reminder-button").data("hasreminder", "False");
            $(".js-reminder-button > i").removeClass("gray");
            $(".js-reminder-button > i").removeClass("green");
            $(".js-reminder-button").attr("data-original-title", Localization_Reminder);
            $("#dialog-show-reminders").dialog("close");
        }
    });
}

var refreshReminderBlockInDialog = false;
var reminderSetTimeDate = ""; // datum pro změnu z dialogu kde se nastavuje čas
var $postponeElement = undefined;
var postponeDialog = false;

function openReminderAddHoursDialog(e) {
    e.stopPropagation();
    e.preventDefault();
    $("#dialog-reminder-add-hours").dialog("open");
}

function openReminderTomorrowDialog(e, element) {
    e.stopPropagation();
    e.preventDefault();
    reminderSetTimeDate = $(element).closest(".js-reminder").data("date");
    $("#dialog-reminder-tomorrow").dialog("open");
}

function openReminderNextWeekDialog(e, element) {
    e.stopPropagation();
    e.preventDefault();
    reminderSetTimeDate = $(element).closest(".js-reminder").data("date");
    $("#dialog-reminder-next-week").dialog("open");
}

function refreshReminderDialogContent() {
    $("#dialog-show-reminders > div").html("<div class='loading-32'></div>");
    $("#dialog-show-reminders > div").load(RQ_URL + "/Tickets/Reminder/" + ticketId);
}

function openReminderDialog(e) {
    $("#dialog-select-reminder").dialog("open");
}

function openPostponeAddHoursDialog(e, element, dialog) {
    postponeDialog = dialog;
    $postponeElement = $(element);
    e.stopPropagation();
    e.preventDefault();
    $("#dialog-postponed-until-add-hours").dialog("open");
}

function openPostponeNextWeekTimeDialog(e, element, dialog) {
    e.stopPropagation();
    e.preventDefault();
    postponeDialog = dialog;
    $postponeElement = $(element);
    $("#dialog-postponed-until-next-week").dialog("open");
}

function openPostponeTomorrowTimeDialog(e, element, dialog) {
    e.stopPropagation();
    e.preventDefault();
    postponeDialog = dialog;
    $postponeElement = $(element);
    $("#dialog-postponed-until-tomorrow").dialog("open");
}

function openPostponeDialog() {
    $("#dialog-postponed-until").dialog("open");
}

function removePostponeDialog() {
    $("#dialog-postponed-until-confirm-remove").dialog("open");
}

function showSetPosponedUntilDialog() {
    postponeDialog = true;
    $("#dialog-postponed-until-set-time").dialog("open");
}

// ------------------- ZIP ARCHIVE DOWNLOAD -----------------------------------

function getDataAttachmentsOfUserMessage(el, id) {
    $(el).prop('disabled', true);
    OnAjaxBegin(Localization_DownloadingArchive);
    $.getJSON(RQ_URL + '/Tickets/PrepareDataAttachmentsOfUserMessage/' + id, function (data) {
        $(el).prop('disabled', false);
        OnAjaxComplete();
        location.replace(RQ_URL + '/Tickets/GetDataAttachmentsOfUserMessage/' + id + '?fileId=' + data);
    });
}


/* -------------------- MESSAGES TYPE ---------------------------- */

function ShowMessagesType(messagesType, speed) {
    if (messagesType == "COMMENTS_ONLY") {
        ShowSystemMessages(false, speed);
        ShowTicketMessages(true, speed, false);
    }
    else if (messagesType == "PUBLIC_COMMENTS_ONLY") {
        ShowSystemMessages(false, speed);
        ShowTicketMessages(true, speed, true);
    }
    else if (messagesType == "EVENTS_ONLY") {
        ShowTicketMessages(false, speed, false);
        ShowSystemMessages(true, speed);
    }
    else if (messagesType == "ALL") {
        ShowTicketMessages(true, speed, false);
        ShowSystemMessages(true, speed);
    }

    $('#divMessagesType > button').removeClass('active');
    $('#divMessagesType > button[data-message-type=' + messagesType + ']').addClass('active');

    $.cookie("TicketViewShowMessagesType-" + LoggedUserProviderKey, messagesType, { path: '/', expires: 365 });
}

function ShowSystemMessages(show, speed) {
    if (show) {
        $('.communication-note').show(speed);
    }
    else {
        $('.communication-note').hide(speed);
    }
}

function ShowTicketMessages(show, speed, publicOnly) {
    if (show) {
        $("div.timeline div.comment" + (publicOnly ? ":not(.private)" : "")).show(speed);

        if (publicOnly)
            $("div.timeline div.comment.private").hide(speed);
    }
    else {
        $("div.timeline div.comment").hide(speed);
    }
}

function GetPredefinedReplyHtml(tiny, replyId) {
    OnAjaxBegin();
    $.get(
        RQ_URL + "/Tickets/GetPredefinedReplyHtml",
        {
            id: replyId,
        },
        function (data) {
            tiny.execCommand('mceInsertContent', false, data);
        },
        "html"
    )
        .done(function () {
            OnAjaxComplete();
        });
}