﻿var selectedIds = Array();
var selectAllByConditions = false;
$(document).ready(function () {
    initDateRangePicker("#FilterTimespan");
    initDateRangePicker("#FilterInvoiceTimespan");

    $(".datepicker").datepicker();

    $("body").on("click", ".showFilter", function () {
        if (!$("#TrackTimeRecordsFilter").is(":visible")) {
            $("#TrackTimeRecordsFilter").show();
        }
        else {
            $("#TrackTimeRecordsFilter").hide();
        }
    });

    $("body").on("click", ".closeFilter", function () {
        $("#FilterTimespan").val("");
        $("#FilterInvoiceTimespan").val("");
        $("#FilterTicketId").val(null);
        $("#FilterTicketId").trigger("change");
        $("#FilterCustomerId").val(null);
        $("#FilterCustomerId").trigger("change");
        $("#FilterActivityId").val(null);
        $("#FilterActivityId").trigger("change");
        $("#FilterUserProviderKey").val(null);
        $("#FilterUserProviderKey").trigger("change");
        $("#FilterGroupId").val(null);
        $("#FilterGroupId").trigger("change.select2");
        $("#FilterInvoice").val(null);
        $("#FilterInvoice").trigger("change");
        $("#FilterApproved").val(null);
        $("#FilterApproved").trigger("change");

        $("#TrackTimeRecordsFilter").hide();

        filterJqGrid();
    });

    $("#dialog-confirm-delete-track-time-records").dialog({
        autoOpen: false,
        modal: true,
        width: "auto",
        resizable: false,
        buttons:
            [{
                text: Localization_Yes,
                click: function () {
                    OnAjaxBegin();
                    $.ajax({
                        url: RQ_URL + '/TrackTimeRecords/DeleteTrackTimeRecords',
                        data: {
                            selectedIds: selectedIds,
                            selectAll: selectAllByConditions,
                            timespan: $("#FilterTimespan").val(),
                            invoiceTimespan: $("#FilterInvoiceTimespan").val(),
                            ticketId: $("#FilterTicketId").val(),
                            customerId: $("#FilterCustomerId").val(),
                            activityId: $("#FilterActivityId").val(),
                            userProviderKeys: $("#FilterUserProviderKey").val(),
                            invoices: $("#FilterInvoice").val(),
                            myTrackTimeRecords: $("#ShowMyTrackTimeRecords").hasClass("active"),
                            groupId: $("#FilterGroupId").val(),
                            approved: $("#FilterApproved").val(),
                        },
                        type: "POST",
                        error: function (error) { alert(error.responseText); },
                        complete: function () {
                            OnAjaxComplete();
                            cleanSelectedIds();
                            reloadJqGrid();
                            $("#dialog-confirm-delete-track-time-records").dialog("close");
                        }
                    });
                }
            }, {
                text: Localization_No,
                click: function () {
                    $("#dialog-confirm-delete-track-time-records").dialog("close");
                }
            }]
    });

    $(".js-global-action-delete").click(function () {
        $("#dialog-confirm-delete-track-time-records").dialog("open");
    });

    setRedirectGroupButton();

    $("#FilterGroupId").change(function () {
        setRedirectGroupButton();
        reloadJqGrid();
    });

    filterSetBackground();

    $('#DialogSetApprovalApproval').bootstrapToggle();

    $(".nav-tabs").on("click", "a", function () {
        $(".nav-tabs > li").removeClass("active");
        $(this).closest("li").addClass("active");
        $("#jqGridTrackTimeRecords").setGridParam({
            page: 1
        })
        reloadJqGrid();
    });

    $("#jqGridTrackTimeRecords").jqGrid({
        url: RQ_URL + "/TrackTimeRecords/Data",
        mtype: "GET",
        styleUI: 'Bootstrap',
        datatype: "json",
        autoencode: true,
        colModel: [
            { name: 'Id', hidden: true, key: true }, //this id gets onSelectRow/All
            { label: Localization_Date, name: 'DateOfImplementation', width: 20, search: false, align: 'center' },
            { label: Localization_TrackTimeRecords_Record, name: 'Data', formatter: dataFormatter, width: 48, search: false, sortable: false },
            { label: Localization_Description, name: 'Description', formatter: descriptionFormatter, width: 80, sortable: false, search: false },
            { label: Localization_TrackTimeRecords_Company, name: 'CustomerName', formatter: customerFormatter, width: 40, search: false },
            { label: Localization_TrackTimeRecords_Project, name: 'Group', width: 40, formatter: groupFormatter, sortable: false, search: false },
            { label: Localization_TrackTimeRecords_Ticket, name: 'TicketRef', width: 25, sortable: false, formatter: ticketRefFormatter, search: false },
            { label: Localization_TrackTimeRecords_Operator, name: 'AssignedToUserFullName', formatter: formatAvatar, width: 30, sortable: false, search: false },
            { name: 'AssignedToUserProviderKey', hidden: true },
            {
                label: Localization_Actions,
                name: "actions",
                sortable: false,
                formatter: myActions,
                search: false,
                fixed: true,
                title: false,
                width: 90
            },
        ],
        shrinkToFit: true,
        autowidth: true,
        multiselectWidth: 60,
        viewrecords: true,
        sortname: 'DateOfImplementation',
        sortorder: "desc",
        multiselect: true,
        height: 'auto',
        rowNum: 20,
        scrollOffset: 0,
        rowList: [20, 30, 50],
        onSelectRow: function (id, isSelected) {
            SelectRowEvent(id, isSelected);
        },
        onSelectAll: function (id, isSelected) {
            for (i = 0; i < id.length; i++) {
                SelectRowEvent(id[i], isSelected)
            };
            $(".js-remove-all-rows").hide();
            if (isSelected && $("#jqGridTrackTimeRecords").jqGrid('getGridParam', 'lastpage') > 1) {
                $(".js-total-number-of-track-time-records").text($("#jqGridTrackTimeRecords").jqGrid('getGridParam', 'records'))
                $(".js-add-all-rows").show();
            } else if ($("#jqGridTrackTimeRecords").jqGrid('getGridParam', 'lastpage') > 1) {
                selectAllByConditions = false;
                $(".js-add-all-rows").hide();
            }
        },
        loadComplete: function (data) {
            initBsTooltip();
            for (var i = 0; i < selectedIds.length; i++) {
                $(this).jqGrid('setSelection', selectedIds[i], false);
            }
            disableOrEnableJqGridCheckboxes();
            reloadSummation();
        },
        beforeSelectRow: function (rowid, e) {
            var cbsdis = $("tr#" + rowid + ".jqgrow > td > input.cbox:disabled", $("#jqGridTrackTimeRecords"));
            if (cbsdis.length === 0) {
                return true;    // allow select the row
            } else {
                return false;   // not allow select the row
            }
        },
        pager: "#jqGridTrackTimeRecordsPager",
        grouping: false,
        groupingView: {
            groupField: ["TicketRef"],
            groupColumnShow: [false],
            groupText: ["<b>{0}</b>"],
            groupOrder: ["asc"],
            groupSummary: [false],
            groupCollapse: false

        },
        postData: {
            timespan: function () { return $("#FilterTimespan").val(); },
            invoiceTimespan: function () { return $("#FilterInvoiceTimespan").val(); },
            ticketId: function () { return $("#FilterTicketId").val(); },
            customerId: function () { return $("#FilterCustomerId").val(); },
            activityId: function () { return $("#FilterActivityId").val(); },
            userProviderKeys: function () { return $("#FilterUserProviderKey").val() == null ? "" : $("#FilterUserProviderKey").val(); },
            invoices: function () { return $("#FilterInvoice").val() == null ? "" : $("#FilterInvoice").val(); },
            myTrackTimeRecords: function () { return $("#ShowMyTrackTimeRecords").hasClass("active"); },
            groupId: function () { return $("#FilterGroupId").val(); },
            approved: function () {
                return $("#FilterApproved").val();
            },
        }
    });

    $('#jqGridTrackTimeRecords').jqGrid().setGridParam(
        {
            gridComplete: function () {
                $(".deleteLink").click(function (e) {
                    e.preventDefault();
                    var trackTimeDeleteId = $(this).data("id");

                    $("#dialog-confirm-delete-track-time-record").dialog({
                        buttons: [{
                            text: Localization_Yes,
                            click: function () {
                                DeleteTrackTimeRecord(trackTimeDeleteId);
                                $(this).dialog("close");
                            }
                        }, {
                            text: Localization_No,
                            click: function () {
                                $(this).dialog("close");
                            }
                        }]
                    });

                    $("#dialog-confirm-delete-track-time-record").dialog("open");
                });
            },
        });

    $('#jqGridTrackTimeRecords').jqGrid('navGrid', "#jqGridTrackTimeRecordsPager", {
        search: false, // show search button on the toolbar
        add: false,
        edit: false,
        del: false,
        refresh: true
    });

    $('#GroupBy').select2({ width: 'resolve', allowClear: true, placeholder: Localization_TrackTimeRecords_Grouping });
    // on chang select value change grouping

    $("#GroupBy").on("select2:unselect, change", function (e) {
        var vl = $(this).val();
        if (vl) {
            $("#jqGridTrackTimeRecords").jqGrid('groupingGroupBy', vl);
        } else {
            $("#jqGridTrackTimeRecords").jqGrid('groupingRemove', true);
        }
        $("#jqGridTrackTimeRecords").setGridWidth($("ul.nav-tabs").width());
    });

    $("#dialog-confirm-delete-track-time-record").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Yes,
            click: function () {
                DeleteTrackTimeRecord(trackTimeRecordIdGlobal);
                $(this).dialog("close");
            }
        }, {
            text: Localization_No,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#dialog-confirm-can-change-activity-type").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Ok,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#dialog-set-group").dialog({
        autoOpen: false,
        resizable: false,
        width: "500",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Set,
            click: function () {
                OnAjaxBegin();
                $.ajax({
                    url: RQ_URL + '/TrackTimeRecords/BulkActionSetProject',
                    data: {
                        selectedIds: selectedIds,
                        selectAll: selectAllByConditions,
                        timespan: $("#FilterTimespan").val(),
                        invoiceTimespan: $("#FilterInvoiceTimespan").val(),
                        ticketId: $("#FilterTicketId").val(),
                        customerId: $("#FilterCustomerId").val(),
                        activityId: $("#FilterActivityId").val(),
                        userProviderKeys: $("#FilterUserProviderKey").val(),
                        invoices: $("#FilterInvoice").val(),
                        myTrackTimeRecords: $("#ShowMyTrackTimeRecords").hasClass("active"),
                        groupId: $("#FilterGroupId").val(),
                        approved: $("#FilterApproved").val(),
                        groupIdForSet: $("#DialogSetGroupGroupId").val(),
                    },
                    type: "POST",
                    error: function (error) { alert(error.responseText); },
                    success: function (result) {
                        OnAjaxComplete();
                        selectedIds = result.ids;
                        refreshBulkActionButtonsAndLabels();
                        reloadJqGrid();
                        $("#dialog-set-group").dialog("close");
                    }
                });
            }
        }, {
            text: Localization_Cancel,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#DialogSetInvoiceInvoiceState").change(function () {
        $(".js-dialog-set-invoice-columns").hide();
        if ($(this).val() == "Invoiced") {
            $(".js-dialog-set-invoice-columns").show();
        }
    });

    $("#dialog-set-invoice").dialog({
        autoOpen: false,
        resizable: false,
        width: "500",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Set,
            click: function () {
                OnAjaxBegin();
                $.ajax({
                    url: RQ_URL + '/TrackTimeRecords/BulkActionSetInvoiceState',
                    data: {
                        selectedIds: selectedIds,
                        selectAll: selectAllByConditions,
                        timespan: $("#FilterTimespan").val(),
                        invoiceTimespan: $("#FilterInvoiceTimespan").val(),
                        ticketId: $("#FilterTicketId").val(),
                        customerId: $("#FilterCustomerId").val(),
                        activityId: $("#FilterActivityId").val(),
                        userProviderKeys: $("#FilterUserProviderKey").val(),
                        invoices: $("#FilterInvoice").val(),
                        myTrackTimeRecords: $("#ShowMyTrackTimeRecords").hasClass("active"),
                        groupId: $("#FilterGroupId").val(),
                        approved: $("#FilterApproved").val(),
                        invoiceStateForSet: $("#DialogSetInvoiceInvoiceState").val(),
                        invoiceNumberForSet: $("#DialogSetInvoiceInvoiceNumber").val(),
                        invoiceDateForSet: $("#DialogSetInvoiceInvoiceDate").val(),
                    },
                    type: "POST",
                    error: function (error) { alert(error.responseText); },
                    success: function (result) {
                        OnAjaxComplete();
                        selectedIds = result.ids;
                        refreshBulkActionButtonsAndLabels();
                        reloadJqGrid();
                        $("#dialog-set-invoice").dialog("close");
                    }
                });
            }
        }, {
            text: Localization_Cancel,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#dialog-set-operator").dialog({
        autoOpen: false,
        resizable: false,
        width: "500",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Set,
            click: function () {
                $(".js-dialog-set-operator-operator-error").hide();
                if ($("#DialogSetOperatorOperator").val() == null) {
                    $(".js-dialog-set-operator-operator-error").show();
                } else {
                    OnAjaxBegin();
                    $.ajax({
                        url: RQ_URL + '/TrackTimeRecords/BulkActionSetOperator',
                        data: {
                            selectedIds: selectedIds,
                            selectAll: selectAllByConditions,
                            timespan: $("#FilterTimespan").val(),
                            invoiceTimespan: $("#FilterInvoiceTimespan").val(),
                            ticketId: $("#FilterTicketId").val(),
                            customerId: $("#FilterCustomerId").val(),
                            activityId: $("#FilterActivityId").val(),
                            userProviderKeys: $("#FilterUserProviderKey").val(),
                            invoices: $("#FilterInvoice").val(),
                            myTrackTimeRecords: $("#ShowMyTrackTimeRecords").hasClass("active"),
                            groupId: $("#FilterGroupId").val(),
                            approved: $("#FilterApproved").val(),
                            operatorForSet: $("#DialogSetOperatorOperator").val(),
                        },
                        type: "POST",
                        error: function (error) { alert(error.responseText); },
                        success: function (result) {
                            OnAjaxComplete();
                            selectedIds = result.ids;
                            refreshBulkActionButtonsAndLabels();
                            reloadJqGrid();
                            $("#dialog-set-operator").dialog("close");
                        }
                    });
                }
            }
        }, {
            text: Localization_Cancel,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });

    $("#dialog-set-customer").dialog({
        autoOpen: false,
        resizable: false,
        width: "500",
        height: "auto",
        modal: true,
        buttons:
            [{
                text: Localization_Set,
                click: function () {
                    OnAjaxBegin();
                    $.ajax({
                        url: RQ_URL + '/TrackTimeRecords/BulkActionSetCustomer',
                        data: {
                            selectedIds: selectedIds,
                            selectAll: selectAllByConditions,
                            timespan: $("#FilterTimespan").val(),
                            invoiceTimespan: $("#FilterInvoiceTimespan").val(),
                            ticketId: $("#FilterTicketId").val(),
                            customerId: $("#FilterCustomerId").val(),
                            activityId: $("#FilterActivityId").val(),
                            userProviderKeys: $("#FilterUserProviderKey").val(),
                            invoices: $("#FilterInvoice").val(),
                            myTrackTimeRecords: $("#ShowMyTrackTimeRecords").hasClass("active"),
                            groupId: $("#FilterGroupId").val(),
                            approved: $("#FilterApproved").val(),
                            customerForSet: $("#DialogSetCustomerCustomer").val(),
                        },
                        type: "POST",
                        error: function (error) { alert(error.responseText); },
                        success: function (result) {
                            OnAjaxComplete();
                            selectedIds = result.ids;
                            refreshBulkActionButtonsAndLabels();
                            reloadJqGrid();
                            $("#dialog-set-customer").dialog("close");
                        }
                    });
                }
            }, {
                text: Localization_Cancel,
                click: function () {
                    $(this).dialog("close");
                }
            }]
    });
    $("#dialog-set-approval").dialog({
        autoOpen: false,
        resizable: false,
        width: "500",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Set,
            click: function () {
                OnAjaxBegin();
                $.ajax({
                    url: RQ_URL + '/TrackTimeRecords/BulkActionSetApproval',
                    data: {
                        selectedIds: selectedIds,
                        selectAll: selectAllByConditions,
                        timespan: $("#FilterTimespan").val(),
                        invoiceTimespan: $("#FilterInvoiceTimespan").val(),
                        ticketId: $("#FilterTicketId").val(),
                        customerId: $("#FilterCustomerId").val(),
                        activityId: $("#FilterActivityId").val(),
                        userProviderKeys: $("#FilterUserProviderKey").val(),
                        invoices: $("#FilterInvoice").val(),
                        myTrackTimeRecords: $("#ShowMyTrackTimeRecords").hasClass("active"),
                        groupId: $("#FilterGroupId").val(),
                        approved: $("#FilterApproved").val(),
                        approvalForSet: $("#DialogSetApprovalApproval").is(":checked"),
                    },
                    type: "POST",
                    error: function (error) { alert(error.responseText); },
                    success: function (result) {
                        OnAjaxComplete();
                        selectedIds = result.ids;
                        refreshBulkActionButtonsAndLabels();
                        reloadJqGrid();
                        $("#dialog-set-approval").dialog("close");
                    }
                });
            }
        }, {
            text: Localization_Cancel,
            click: function () {
                $(this).dialog("close");
            }
        }]
    });
    $("#dialog-set-activity").dialog({
        autoOpen: false,
        resizable: false,
        width: "500",
        height: "auto",
        modal: true,
        buttons:
            [{
                text: Localization_Set,
                click: function () {
                    $(".js-dialog-set-activity-activity-error").hide();
                    if ($("#DialogSetActivityActivity").val() == null) {
                        $(".js-dialog-set-activity-activity-error").show();
                    } else {
                        OnAjaxBegin();
                        $.ajax({
                            url: RQ_URL + '/TrackTimeRecords/BulkActionSetActivity',
                            data: {
                                selectedIds: selectedIds,
                                selectAll: selectAllByConditions,
                                timespan: $("#FilterTimespan").val(),
                                invoiceTimespan: $("#FilterInvoiceTimespan").val(),
                                ticketId: $("#FilterTicketId").val(),
                                customerId: $("#FilterCustomerId").val(),
                                activityId: $("#FilterActivityId").val(),
                                userProviderKeys: $("#FilterUserProviderKey").val(),
                                invoices: $("#FilterInvoice").val(),
                                myTrackTimeRecords: $("#ShowMyTrackTimeRecords").hasClass("active"),
                                groupId: $("#FilterGroupId").val(),
                                approved: $("#FilterApproved").val(),
                                activityForSet: $("#DialogSetActivityActivity").val(),
                            },
                            type: "POST",
                            error: function (error) { alert(error.responseText); },
                            success: function (result) {
                                selectedIds = result.ids;
                                OnAjaxComplete();
                                refreshBulkActionButtonsAndLabels();
                                reloadJqGrid();
                                $("#dialog-set-activity").dialog("close");
                            }
                        });
                    }
                }
            }, {
                text: Localization_Cancel,
                click: function () {
                    $(this).dialog("close");
                }
            }]
    });

    $("#dialog-summation").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [{
            text: Localization_Close,
            click: function () {
                $(this).dialog("close");
            },
        }]
    });

    $("#FilterUserProviderKey").select2({
        minimumInputLength: 0,
        width: '100%',
        multiple: true,
        placeholder: Localization_Search,
        ajax: {
            url: RQ_URL + '/Account/UsersForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                    includeSmartUsers: false,
                    includeEndUsers: false,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: true,
        },
        escapeMarkup: function (markup) { return markup; },
        templateResult: formatUsersForSelect2AjaxData,
        templateSelection: formatUsersForSelect2AjaxElement,
    });

    $("#DialogSetOperatorOperator").select2({
        minimumInputLength: 0,
        width: '100%',
        placeholder: Localization_Search,
        ajax: {
            url: RQ_URL + '/Account/UsersForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                    includeSmartUsers: false,
                    includeEndUsers: false,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: true,
        },
        escapeMarkup: function (markup) { return markup; },
        templateResult: formatUsersForSelect2AjaxData,
        templateSelection: formatUsersForSelect2AjaxElement,
    });
    $("#FilterActivityId").trigger("change");
});

function setRedirectGroupButton() {
    if ($("#FilterGroupId").val() == "") {
        $("#RedirectToTheGroup").prop("disabled", true);
    } else {
        $("#RedirectToTheGroup").prop("disabled", false);
    }
}

function redirectToTheGroup() {
    window.location.href = RQ_URL + '/Admin/TrackTimeGroups/Edit/' + $("#FilterGroupId").val();
}

function SelectRowEvent(id, isSelected) {
    if (isSelected) {
        //item selected, add index to array
        if (selectedIds.indexOf(Number(id)) == -1) {
            selectedIds.push(Number(id));
        }
    }
    else {
        //item deselected, remove from array
        var index = selectedIds.indexOf(Number(id))

        if (index != -1) {
            selectedIds.splice(index, 1);
        }
    }
    refreshBulkActionButtonsAndLabels();
}

function filterJqGrid() {
    filterSetBackground();
    cleanSelectedIds();
    reloadJqGrid();
}

function cleanSelectedIds() {
    selectedIds = [];
    refreshBulkActionButtonsAndLabels();
}

function refreshBulkActionButtonsAndLabels() {
    if ($("#TotalNumberOfRows").length > 0) {
        $("#TotalNumberOfRows").text("(" + selectedIds.length + ")");
    } else {
        $("#jqgh_jqGridTrackTimeRecords_cb").append("<span id='TotalNumberOfRows'>(" + selectedIds.length + ")</span>");
    }
    if (selectedIds.length == 0 && $("#TotalNumberOfRows").length > 0) {
        $("#TotalNumberOfRows").remove();
    }
    $('.js-global-action-grid-buttons').prop('disabled', !selectAllByConditions && selectedIds.length == 0);
}

function myActions(cellValue, options, rowObject) {
    var actionHtml =
        "<a data-toggle='tooltip' title='" + Localization_TrackTimeRecords_Copy + "' href='javascript:CreateCopyFromTrackTimeRecordDialog(\"#dialog-track-time-record\",\"#trackTimeRecordSaveButton\"," + rowObject.Id + ", 1)' ><i class=\"fa fa-clone fa-lg\"></i></a>" +
        "&nbsp;&nbsp;<a data-toggle='tooltip' title='" + Localization_Edit + "' href='javascript:OpenEditTrackTimeRecordDialog(\"#dialog-track-time-record\",\"#trackTimeRecordSaveButton\"," + rowObject.Id + ", 1, false)' class='jqgrid-bootstrap-table-edit' ><i class=\"fa fa-pencil-square-o fa-lg\"></i></a>" +
        "&nbsp;&nbsp;<a class='deleteLink jqgrid-bootstrap-table-delete' data-toggle='tooltip' title='" + Localization_Delete + "' href='javascript:void(0)' data-id='" + rowObject.Id + "' ><i class=\"fa fa-trash-o fa-lg\"></i></a>";
    return actionHtml;
}

function ticketRefFormatter(cellValue, options, rowObject, action) {
    if ((action == undefined && cellValue != null) || (rowObject != undefined && rowObject.TicketExists == true)) {
        return "<a href='" + RQ_URL + "/Tickets/Show/" + cellValue + "'>" + cellValue + "</a>";
    }
    else {
        return "<span data-toggle='tooltip' title='" + Localization_TrackTimeRecords_WithoutTicket + "'>-</span>";
    }
}

function groupFormatter(cellValue, options, rowObject, action) {
    if (cellValue != null && (action == undefined || rowObject != undefined)) {
        return '<i class="fas fa-project-diagram" aria-hidden="true" style="color:' + rowObject.GroupColor + '"></i> ' + cellValue;
    } else {
        return '';
    }
}

function descriptionFormatter(cellValue, options, rowObject, action) {
    if (cellValue != "" && cellValue != null) {
        return "<a data-toggle='tooltip' title='" + Localization_Edit + "' href='javascript:OpenEditTrackTimeRecordDialog(\"#dialog-track-time-record\",\"#trackTimeRecordSaveButton\"," + rowObject.Id + ", 1, false)'>" + cellValue + "</a>";
    }
    return "";
}

function customerFormatter(cellValue, options, rowObject, action) {
    if (action == undefined) {
        if (cellValue != null) {
            return cellValue;
        }
    }
    if (cellValue != "" && cellValue != null) {
        return "<a data-toggle='tooltip' title='" + cellValue + "' href='" + RQ_URL + "/Customers/Edit/" + rowObject.CustomerId + "'>" + cellValue + "</a>";
    }
    return "";
}

function dataFormatter(cellValue, options, rowObject, action) {
    var html = "<div class='left text-right margin-right-small' style='min-width: 70px;'>"; //DIV A
    if (rowObject.Approved) {
        html += "<i class='fa fa-thumbs-o-up gray left' style='margin-top: 2px; margin-right: 3px;' data-toggle='tooltip' title='schváleno'></i>";
    }

    html += "<a data-toggle='tooltip' title='" + Localization_Edit + "' href='javascript:OpenEditTrackTimeRecordDialog(\"#dialog-track-time-record\",\"#trackTimeRecordSaveButton\"," + rowObject.Id + ", 1, false)'>"

    if (rowObject.ActivityType == ActivityTypeGeneral) {
        html += "<div class='right'><strong>" + rowObject.Count + "</strong> " + rowObject.GeneralUnitLabel + "</div>";
    } else if (rowObject.ActivityType == ActivityTypeTime) {
        html += rowObject.Duration;
    }
    else {
        return "Not implemented";
    }

    html += "</a>";
    html += "</div>"; //END DIV A

    if (rowObject.ActivityType == ActivityTypeTime) {
        html += "<div class='left text-center' style='min-width: 80px;'>";
        html += "<a data-toggle='tooltip' title='" + Localization_Edit + "' href='javascript:OpenEditTrackTimeRecordDialog(\"#dialog-track-time-record\",\"#trackTimeRecordSaveButton\"," + rowObject.Id + ", 1, false)'>"
        html += "<small><div class='inline'>" + rowObject.From + " &ndash;</div> <div class='inline'>" + rowObject.To + "</div></small>"
        html += "</a>";
        html += "</div>";
    }

    return html;
}

function formatAvatar(cellValue, options, rowObject, action) {
    if (action == undefined) {
        return cellValue;
    }
    else if (rowObject != undefined) {
        var avatarHtml = "";
        if (rowObject.AssignedToUserProviderKey != null) {
            avatarHtml = rowObject.AssignedToUserAvatar;
        }
        return avatarHtml + " <span>" + htmlEncode(rowObject.AssignedToUserFullName) + "</span>";
    }
    else {
        return "";
    }
}

function newTrackTimeRecord() {
    OpenAddTrackTimeRecordDialog("#dialog-track-time-record", "#trackTimeRecordSaveButton", null, 1, false);
}

function reloadSummation() {
    $.ajax({
        url: RQ_URL + '/TrackTimeRecords/GetCounts',
        type: "GET",
        error: function (error) { alert(error.responseText); },
        success: function (data) {
            $("#TotalTrackTimeRecordsCount").text(data.TotalTrackTimeRecordsCount);
            $("#MyTrackTimeRecordsCount").text(data.MyTrackTimeRecordsCount);
        }
    });
}

function OnTrackTimeRecordDeleteAjaxComplete() {
    $("#dialog-confirm-delete-track-time-record").dialog('close');
    reloadJqGrid();
}

function reloadJqGrid() {
    $('#jqGridTrackTimeRecords').trigger("reloadGrid");
}

function showSummation() {
    $("#dialog-summation").html("<div class='loading-32'></div>");
    $("#dialog-summation").dialog("open");
    $.ajax({
        url: RQ_URL + '/TrackTimeRecords/Summation',
        data: {
            selectedIds: selectedIds,
            timespan: $("#FilterTimespan").val(),
            invoiceTimespan: $("#FilterInvoiceTimespan").val(),
            ticketId: $("#FilterTicketId").val(),
            customerId: $("#FilterCustomerId").val(),
            activityId: $("#FilterActivityId").val(),
            userProviderKeys: $("#FilterUserProviderKey").val(),
            invoices: $("#FilterInvoice").val(),
            myTrackTimeRecords: $("#ShowMyTrackTimeRecords").hasClass("active"),
            groupId: $("#FilterGroupId").val(),
            approved: $("#FilterApproved").val(),
        },
        type: "POST",
        error: function (error) { alert(error.responseText); },
        success: function (data) {
            $("#dialog-summation").html(data);
            $("#dialog-summation").dialog("close");
            $("#dialog-summation").dialog("open");
        }
    });
}

function openDialogSetGroup() {
    $("#dialog-set-group").dialog("open");
}

function openDialogSetInvoice() {
    $("#DialogSetInvoiceInvoiceState").trigger("change");
    $("#dialog-set-invoice").dialog("open");
}

function openDialogSetOperator() {
    $(".js-dialog-set-operator-operator-error").hide();
    $("#DialogSetOperatorOperator").val(null);
    $("#DialogSetOperatorOperator").trigger("change");
    $("#dialog-set-operator").dialog("open");
}

function openDialogSetCustomer() {
    $("#dialog-set-customer").dialog("open");
}

function openDialogSetApproval() {
    $("#dialog-set-approval").dialog("open");
}

function openDialogSetActivity() {
    OnAjaxBegin(Localization_Checking);
    $.ajax({
        url: RQ_URL + '/TrackTimeRecords/GetActivityTypesForTrackTimerRecords',
        data: {
            selectedIds: selectedIds,
            selectAll: selectAllByConditions,
            timespan: $("#FilterTimespan").val(),
            invoiceTimespan: $("#FilterInvoiceTimespan").val(),
            ticketId: $("#FilterTicketId").val(),
            customerId: $("#FilterCustomerId").val(),
            activityId: $("#FilterActivityId").val(),
            userProviderKeys: $("#FilterUserProviderKey").val(),
            invoices: $("#FilterInvoice").val(),
            myTrackTimeRecords: $("#ShowMyTrackTimeRecords").hasClass("active"),
            groupId: $("#FilterGroupId").val(),
            approved: $("#FilterApproved").val(),
        },
        type: "POST",
        error: function (error) { alert(error.responseText); },
        success: function (result) {
            OnAjaxComplete();
            if (result.Success) {
                $("#DialogSetActivityActivity").val([]).trigger('change');
                $("#DialogSetActivityActivity option").prop("disabled", true);
                $("#DialogSetActivityActivity option[data-type='" + result.ActivityType + "']").prop("disabled", false);
                $("#DialogSetActivityActivity option:first").prop("disabled", false);
                $('#DialogSetActivityActivity').select2({
                    width: '100%',
                    allowClear: true,
                    placeholder: Localization_TrackTimeRecords_PleaseChooseActivity,
                    templateResult: select2FormatOneIconAndMoreColors,
                    templateSelection: select2FormatOneIconAndMoreColors
                });
                $("#dialog-set-activity").dialog("open");
            } else {
                $("#dialog-confirm-can-change-activity-type").dialog("open");
            }
        }
    });
}

function selectAll() {
    selectAllByConditions = true;
    disableOrEnableJqGridCheckboxes();
    $(".js-add-all-rows").hide();
    $(".js-remove-all-rows").show();
}

function removeAll() {
    selectAllByConditions = false;
    disableOrEnableJqGridCheckboxes();
    reloadJqGrid();
    $(".js-remove-all-rows").hide();
    $(".js-add-all-rows").hide();
}

function disableOrEnableJqGridCheckboxes() {
    cleanSelectedIds();
    $("#gbox_jqGridTrackTimeRecords .jqgrow").removeClass("success"); //odebere zelené označení
    $("#gbox_jqGridTrackTimeRecords .cbox").prop("checked", false);
    $("#gbox_jqGridTrackTimeRecords .cbox").prop("disabled", selectAllByConditions);
}

function filterSetBackground() {
    if ($("#FilterInvoiceTimespan").val() != "" || $("#FilterTimespan").val() != "" ||
        ($("#FilterTicketId").val() != null && $("#FilterTicketId").val() != "") ||
        ($("#FilterCustomerId").val() != null && $("#FilterCustomerId").val() != "") || $("#FilterActivityId").val() != "" ||
        ($("#FilterUserProviderKey").val() != null && $("#FilterUserProviderKey").val() != "") ||
        ($("#FilterInvoice").val() != null && $("#FilterInvoice").val() != "")||
        ($("#FilterApproved").val() != null && $("#FilterApproved").val() != "")) {
        $(".showFilter").css("background-color", "#5cb85c");
    } else {
        $(".showFilter").css("background-color", "");
    }
}

function print(id) {
    OnAjaxBegin(Localization_CreatingPdf);
    $.ajax({
        url: RQ_URL + '/TrackTimeRecords/SaveDataForExport',
        data: {
            selectedIds: selectedIds,
            selectAll: selectAllByConditions,
            timespan: $("#FilterTimespan").val(),
            invoiceTimespan: $("#FilterInvoiceTimespan").val(),
            ticketId: $("#FilterTicketId").val(),
            customerId: $("#FilterCustomerId").val(),
            activityId: $("#FilterActivityId").val(),
            userProviderKeys: $("#FilterUserProviderKey").val(),
            invoices: $("#FilterInvoice").val(),
            myTrackTimeRecords: $("#ShowMyTrackTimeRecords").hasClass("active"),
            groupId: $("#FilterGroupId").val(),
            approved: $("#FilterApproved").val(),
            groupBy: $("#GroupBy").val(),
        },
        type: "POST",
        error: function (error) { alert(error.responseText); },
        success: function (result) {
            OnAjaxComplete();
            window.location = RQ_URL + "/TrackTimeRecords/Print/" + id;
        }
    });
}

function exportToCsv() {
    OnAjaxBegin(Localization_CreatingCsv);
    $.ajax({
        url: RQ_URL + '/TrackTimeRecords/SaveDataForExport',
        data: {
            selectedIds: selectedIds,
            selectAll: selectAllByConditions,
            timespan: $("#FilterTimespan").val(),
            invoiceTimespan: $("#FilterInvoiceTimespan").val(),
            ticketId: $("#FilterTicketId").val(),
            customerId: $("#FilterCustomerId").val(),
            activityId: $("#FilterActivityId").val(),
            userProviderKeys: $("#FilterUserProviderKey").val(),
            invoices: $("#FilterInvoice").val(),
            myTrackTimeRecords: $("#ShowMyTrackTimeRecords").hasClass("active"),
            groupId: $("#FilterGroupId").val(),
            approved: $("#FilterApproved").val(),
            groupBy: $("#GroupBy").val(),
        },
        type: "POST",
        error: function (error) { alert(error.responseText); },
        success: function (result) {
            OnAjaxComplete();
            window.location = RQ_URL + "/TrackTimeRecords/CreateCsv"
        }
    });
}

function exportSummationToPdf() {
    OnAjaxBegin(Localization_CreatingPdf);
    $.ajax({
        url: RQ_URL + '/TrackTimeRecords/SaveDataForExport',
        data: {
            selectedIds: selectedIds,
            selectAll: selectAllByConditions,
            timespan: $("#FilterTimespan").val(),
            invoiceTimespan: $("#FilterInvoiceTimespan").val(),
            ticketId: $("#FilterTicketId").val(),
            customerId: $("#FilterCustomerId").val(),
            activityId: $("#FilterActivityId").val(),
            userProviderKeys: $("#FilterUserProviderKey").val(),
            invoices: $("#FilterInvoice").val(),
            myTrackTimeRecords: $("#ShowMyTrackTimeRecords").hasClass("active"),
            groupId: $("#FilterGroupId").val(),
            approved: $("#FilterApproved").val(),
            groupBy: $("#GroupBy").val(),
        },
        type: "POST",
        error: function (error) { alert(error.responseText); },
        success: function (result) {
            OnAjaxComplete();
            window.location = RQ_URL + "/TrackTimeRecords/CreateSummationPdf"
        }
    });
}

function exportSummationToCsv() {
    OnAjaxBegin(Localization_CreatingCsv);
    $.ajax({
        url: RQ_URL + '/TrackTimeRecords/SaveDataForExport',
        data: {
            selectedIds: selectedIds,
            selectAll: selectAllByConditions,
            timespan: $("#FilterTimespan").val(),
            invoiceTimespan: $("#FilterInvoiceTimespan").val(),
            ticketId: $("#FilterTicketId").val(),
            customerId: $("#FilterCustomerId").val(),
            activityId: $("#FilterActivityId").val(),
            userProviderKeys: $("#FilterUserProviderKey").val(),
            invoices: $("#FilterInvoice").val(),
            myTrackTimeRecords: $("#ShowMyTrackTimeRecords").hasClass("active"),
            groupId: $("#FilterGroupId").val(),
            approved: $("#FilterApproved").val(),
            groupBy: $("#GroupBy").val(),
        },
        type: "POST",
        error: function (error) { alert(error.responseText); },
        success: function (result) {
            OnAjaxComplete();
            window.location = RQ_URL + "/TrackTimeRecords/CreateSummationCsv"
        }
    });
}